-----------------------------------------------------------------------------------------------
-- RU Localization for Wildstar
-- Copyright (c) http://wildstaronline.ru/
-----------------------------------------------------------------------------------------------
require "Apollo"
require "Window"
require "DatacubeLib"
require "GameLib"
require "ChatSystemLib"
require "QuestLib"
require "ICComm"
require "ICCommLib"
require "GroupLib"



local JSON = Apollo.GetPackage("Lib:dkJSON-2.5").tPackage
local LoadedXMLS={} --убрал local для отладки
local useTranslatedCache=false
local L_AlreadyTranslated={} -- отключено комментом --888 для производительности
local L_FCACHE={}
L_ADDONFCACHE={}
L_DEBUG_CALLS={} --статистика вызовов
L_LOCALSREPLACE={}
local commChan=nil
local useOldTranslatingMethodWithFormDefs=true
local useNewTranslatingMethodWithoutFormDefs=true
local useTAShowHandler=false
local useTAGetStringHandler=true
local gatherDebugInfo=false
local L_WindowClassesAllowedToTranslate={
["Window"]=1,
["Button"]=1,
["MLWindow"]=1,
["ProgressBar"]=1,
["Column"]=1,
}

local L_BlockedFuncsInShowHandler={} -- блокируем некоторые вызовы в wnd:Show в аддоне NamePlates
local L_BlockedFuncsInString_GetWeaselStringHandler={}
local L_BlockedFuncsInformat={}
local L_BlockedFuncsInSetText={}
-- флаг включен или отключен перехват ф-йй
local hookEnabled=false
local firstHookEnable=true

--ускоряем неймплейты
L_BlockedFuncsInShowHandler["DrawName"]=1
L_BlockedFuncsInShowHandler["DrawRewards"]=1
L_BlockedFuncsInShowHandler["DrawGuild"]=1
L_BlockedFuncsInShowHandler["DrawTargeting"]=1
L_BlockedFuncsInShowHandler["DrawHealth"]=1
L_BlockedFuncsInShowHandler["DrawHealthShieldBar"]=1
L_BlockedFuncsInShowHandler["UpdateCastingBar"]=1
L_BlockedFuncsInShowHandler["OnSlowUpdate"]=1
L_BlockedFuncsInShowHandler["OnUpdate"]=1
L_BlockedFuncsInShowHandler["SetTargetHealthAndShields"]=1
L_BlockedFuncsInShowHandler["ResizeQuest"]=1
L_BlockedFuncsInShowHandler["HelperResetUI"]=1


L_BlockedFuncsInString_GetWeaselStringHandler["DrawName"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["DrawGuild"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["DrawHealthShieldBar"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["HelperFormatBigNumber"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["RefreshNameplatesConfigure"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["OnDrawDistanceSlider"]=1
--ускоряем targetframe
L_BlockedFuncsInformat["UpdateCastingBar"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["SetTargetHealthAndShields"]=1
L_BlockedFuncsInformat["OnFrame"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["OnFrame"]=1
--ускоряем квест трекер
L_BlockedFuncsInSetText["RenumberAll"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["HelperShowQuestCallbackBtn"]=1
L_BlockedFuncsInSetText["HelperShowQuestCallbackBtn"]=1 --на самом деле SetTooltip, но они обрабатываются в одной ф-ии
--блокируем перевод команд чата
L_BlockedFuncsInString_GetWeaselStringHandler["BuildInputTypeMenu"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["OnInputMenuEntry"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["OnEmoteCheck"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["OnEmoteMenuEntry"]=1
L_BlockedFuncsInString_GetWeaselStringHandler["HelperRemoveChannelFromInputWindow"]=1

-- Кэш функций для перевода
local L_TraceBefore={}
local L_TraceAfter={}
local L_TraceNot={}
-----------------------------------------------------------------------------------------------
-- Мерзость с переопределением Apollo.GetString нужна чтобы перехватить вызовы которые
-- происходят до установки хука
-----------------------------------------------------------------------------------------------
local ApolloGetString=Apollo.GetString
--12345 отключено для корректной работы сторонних аддонов
Apollo.GetString=function(strId)
	if L_Interface==nil then return end
	local ok=true
			--фикс ошибки в character, там адресуются массивы по имени слота
	if (strId=="InventorySlot_Head") then ok=false end
	if (strId=="InventorySlot_Shoulder") then ok=false end
	if (strId=="InventorySlot_Chest") then ok=false end
	if (strId=="InventorySlot_Hands") then ok=false end
	if (strId=="InventorySlot_Legs") then ok=false end
	if (strId=="InventorySlot_Feet") then ok=false end
	if (strId=="InventorySlot_WeaponPrimary") then ok=false end
	if L_Interface[strId]~=nil and ok then
		strRU=L_Interface[strId]
	else
		strRU=ApolloGetString(strId)
	end
	return strRU
end
--фикс для глючащих неймплейтов (ошибка в 353 строке)
--а так же для ГА
local ApolloTimerCreate=ApolloTimer.Create
ApolloTimer.Create2=function(var1,var2,var3,var4)
	if (var3=="OnPreloadUnitCreateTimer") then
		var1=2.5
	end
	if (var3=="OnPopulateArchiveIndexTimer") then
		var1=1
	end
	return ApolloTimerCreate(var1,var2,var3,var4)
end
--предварительный перехват подгруженных xml-форм
local ApolloCreateFromFile=Apollo.CreateFromFile
Apollo.CreateFromFile=function(strFile)
	local res=ApolloCreateFromFile(strFile)
	if res~=nil then
		LoadedXMLS[res]=string.upper(strFile)
	end
	return res
end

-- см. LoadForm обработчик, функционал совпадает
local ApolloLoadForm=Apollo.LoadForm
Apollo.LoadForm=function(strFile, strFormName, param1, wndParent)
	local res=ApolloLoadForm(strFile, strFormName, param1, wndParent)
	
	local loadedWindow = res 
	local settings={t=1,f=1}
	if (loadedWindow~=nil) then
		local xmlDoc=strFile  -- тут может быть или имя файла или объект xmlDoc
		if (xmlDoc~=nil) then 
			local fileName=nil
			if type(xmlDoc)=="string" then --первым параметром шло имя файла
				local path,file,extension = string.match(xmlDoc, "(.-)([^\\]-([^\\%.]+))$")
				fileName=string.upper(file)
			end
			if type(xmlDoc)=="userdata" then -- первым параметром шел xmlDoc
				fileName=LoadedXMLS[xmlDoc]
			end
			local formName=strFormName
			if (formName=="GRBAddonForm") or (formName=="GRBDebugForm")  then
					settings={t=0,f=0}
			end

			if (type(loadedWindow)=="userdata") then
				local wndDef=nil
				if L_FORMS~=nil and L_FORMS[fileName]~=nil and fileName~=nil then
					wndDef=L_FORMS[fileName]
					wndDef=wndDef[formName]
				end			
				if (wndDef~=nil) and useOldTranslatingMethodWithFormDefs then
					--если найдено определение формы
					if not GRB:GetDisabledState() then
						GRB:TranslateForm(wndDef,loadedWindow,1,settings)
					end	
				else 
					--если не найдено определение формы
					if (formName~=nil) and type(xmlDoc)=="userdata" then --переводим по шаблону xml
						--если хватает данных для перевода по новому методу
						if useNewTranslatingMethodWithoutFormDefs then
							--и если включен метод перевода по xml-источнику
							if not GRB:GetDisabledState() then
								GRB:TranslateLoadedForm(xmlDoc,loadedWindow,formName,settings)
							end	
						end
					end
				end
			else
				--тут у нас loadedWindow не userdata
				--GRB:DebugOut("error parsing LoadForm data")			
			end		
		end
	end
	
	return res

end
-- вызывается после загрузки настроек аддона и соот-но мы можем восстановить нормальный обработчик LoadForm
function GRB:RestoreLoadFormHandle()
	Apollo.LoadForm=ApolloLoadForm
	Apollo.CreateFromFile=ApolloCreateFromFile
	Apollo.GetString=ApolloGetString
end

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function GRB:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
    --debug.sethook(L_Trace, "cr") -- в контексте аддона в обработчик не передается why поэтому трейс - фя глобальная

    return o
end
function GRB:Init()
	L_Saved_Settings=L_Settings 	--инициализация настроек дефолтными значениями
	GRB:OverrideSettings(L_Saved_Settings) --добавляем наши фиксы
	GRB:SetHookFuncs()				--инициализация списка перехватываемых функций
	self:SetHookState() -- включаем перехват
    Apollo.RegisterAddon(self,true,"Gorynych Reborn")
	--Apollo.RegisterAddon(self)
end
-----------------------------------------------------------------------------------------------
-- GRB OnLoad
-----------------------------------------------------------------------------------------------
function GRB:OnLoad()
    -- Register handlers for events, slash commands and timer, etc.
    -- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
	

    Apollo.RegisterSlashCommand("grb", "OnGrbSlash", self)
    Apollo.RegisterSlashCommand("Grb", "OnGrbSlash", self)
    Apollo.RegisterSlashCommand("GRB", "OnGrbSlash", self)
	
    Apollo.RegisterSlashCommand("grbtest", "OnGrbTest", self)
	Apollo.RegisterSlashCommand("grbdebug","OnGrbDebug",self)
    Apollo.RegisterSlashCommand("grbaskseen", "AskSeen", self)
    Apollo.RegisterSlashCommand("grbshowseen", "ShowSeen", self)

	Apollo.RegisterEventHandler("UnitTextBubbleCreate", 		"OnUnitTextBubbleToggled", self)
	Apollo.RegisterEventHandler("UnitTextBubblesDestroyed", 	"OnUnitTextBubbleToggled", self)
	Apollo.RegisterEventHandler("WindowManagementReady", "OnWindowManagementReady", self)

	-- группы рейды и инсты
	Apollo.RegisterEventHandler("Group_Updated",			"OnGroupUpdated", self)				-- ()
	Apollo.RegisterEventHandler("Group_FlagsChanged",		"OnGroupUpdated", self)				-- ()

	Apollo.RegisterTimerHandler("GRBGroupStateTimer", "OnGroupUpdated", self)
	Apollo.CreateTimer("GRBGroupStateTimer",2.0, true)
	------------------------
	--Newly created timers are in the Running state and must be manually stopped.  Timers created this way have no functionality without a timer handler that listens for when the timer fires.  These timers are not destroyed when they fire.
	--While Apollo's timer functionality still works, we are moving more towards using ApolloTimers.  That doesn't mean that this functionality is or will become depricated any time soon (we'll let you know when it does), but you will see far fewer instances of us using them in code.
	--Example
	--	function TimerExample:OnLoad()
	--		Apollo.RegisterTimerHandler("TestTimer", "OnTestTimer", self)
    --		Apollo.CreateTimer("TestTimer", 1.0, false)
	--	end
	--	function TimerExample:OnTestTimer()
	--		Print("Timer has fired")
	--	end
	----------------------------------------------------------------------------

	--загружаем xml с формами
	self.xmlDoc = XmlDoc.CreateFromFile("GRB.xml")

	self.wndMain = Apollo.LoadForm(self.xmlDoc, "GRBAddonForm", nil, self) -- Here we load the addon .xml file with the form elements
	self.wndDebug = Apollo.LoadForm(self.xmlDoc, "GRBDebugForm", nil, self) 
	
	self:ICCommInit()

end
function GRB:ICCommInit()
	Apollo.RegisterTimerHandler("GRBCheckStateTimer", "UpdateCommChannel", self)
	--Runs the CreateTimer method specified with strTimerName, nInterval, bContinuous.
	Apollo.CreateTimer("GRBCheckStateTimer",2, false)
end
function GRB:UpdateCommChannel()
    if not commChan then
        commChan = ICCommLib.JoinChannel("GRBChannel", ICCommLib.CodeEnumICCommChannelType.Global)
		local receiveHookResult=commChan:SetReceivedMessageFunction("OnGRBReceive", self)
		local sendHookResult=commChan:SetSendMessageResultFunction("OnGRBSend", self)
    end
	local res=commChan:IsReady()
    if  res then
		Apollo.StopTimer("GRBCheckStateTimer")
		--self:AnnonceAlive()
    else
        -- Channel not ready yet, repeat in a few seconds
		Apollo.CreateTimer("GRBCheckStateTimer",2, false)
    end
end

function GRB:OnGRBSend(channel, eResult, idMessage)
	-- ICCommLib.CodeEnumICCommMessageResult
	-- 1 - Sent
	-- 2 - Throttled
	-- 3 - NotInChannel
	-- 7 - InvalidText
	-- 8 - MissingEntitlement
end
function GRB:OnGRBReceive(channel, strMessage, idMessage)
	
	local tMsg = JSON.decode(strMessage)
	if tMsg==nil then return end
	if tMsg.strCmd==nil then return end
    if type(tMsg.strCmd) ~= "string" then
        return
    end
	if (tMsg.strCmd=="getSeen") then
		self:ReplySeen(tMsg)
	end
	if (tMsg.strCmd=="imAlive") then
		self:StoreSeen(tMsg)
	end
	if (tMsg.strCmd=="replySeen") then
		self:StoreSeen(tMsg)
	end
	
end
function GRB:AnnonceAlive()
	if not commChan then return end
	if L_Saved_Settings==nil then return end
	local PlayerName= GameLib.GetPlayerUnit():GetName()
	if PlayerName==nil then return end
	local t=GameLib.GetServerTime()
	local tMsg={}
	tMsg.strCmd="imAlive"
	tMsg.Author=PlayerName
	tMsg.Players={}
	tMsg.Players[PlayerName]={}
	tMsg.LastSeen=t
	tMsg.Version=L_Saved_Settings.Version
	tMsg.VersionMinor=L_Saved_Settings.VersionMinor
	tMsg.F=GameLib.GetPlayerUnit():GetFaction()
	tMsg.L=GameLib.GetPlayerUnit():GetLevel()
	tMsg.Players[PlayerName].LastSeen=t
	tMsg.Players[PlayerName].Version=L_Saved_Settings.Version
	tMsg.Players[PlayerName].VersionMinor=L_Saved_Settings.VersionMinor
	tMsg.Players[PlayerName].F=GameLib.GetPlayerUnit():GetFaction()
	tMsg.Players[PlayerName].L=GameLib.GetPlayerUnit():GetLevel()
	local msg_encoded = JSON.encode(tMsg)
	local msgid=commChan:SendMessage(msg_encoded)
end
function GRB:ReplySeen(inMsg)
	if not commChan then return end
	if L_Saved_Settings==nil then return end
	if L_Saved_Settings.Seen==nil then return end
	if GameLib==nil then return end
	local PlayerUnit=GameLib.GetPlayerUnit()
	if PlayerUnit==nil then return end
	local PlayerName= PlayerUnit:GetName()
	if PlayerName==nil then return end
	if inMsg.Author==nil or inMsg.Author==PlayerName then return end

	local tMsg=nil
	local cnt=0
	for key, tCurr in pairs(L_Saved_Settings.Seen) do
		if (tMsg==nil) then
			tMsg={}
			tMsg.Author=PlayerName
			tMsg.strCmd="replySeen"
			tMsg.LastSeen=GameLib.GetServerTime()
			tMsg.Version=L_Saved_Settings.Version
			tMsg.VersionMinor=L_Saved_Settings.VersionMinor
			tMsg.F=GameLib.GetPlayerUnit():GetFaction()
			tMsg.L=GameLib.GetPlayerUnit():GetLevel()
			tMsg.Players={}
			cnt=0
		end
		tMsg.Players[key]=tCurr
		cnt=cnt+1
		if (cnt>100) then
			local msg_encoded = JSON.encode(tMsg)
			commChan:SendPrivateMessage(inMsg.Author,msg_encoded)
			tMsg=nil
		end
	end
	if tMsg~=nil and cnt>0 then
		local msg_encoded = JSON.encode(tMsg)
		commChan:SendPrivateMessage(inMsg.Author,msg_encoded)
	end
end
function GRB:StoreSeen(inMsg)
	if L_Saved_Settings==nil then return end
	if inMsg.Players==nil then return end
	if GameLib==nil then return end
	local PlayerUnit=GameLib.GetPlayerUnit()
	if PlayerUnit==nil then return end
	local PlayerName= PlayerUnit:GetName()
	if PlayerName==nil then return end
	if inMsg.Author==nil or inMsg.Author==PlayerName then return end

	if L_Saved_Settings.Seen==nil then
		L_Saved_Settings.Seen={}
	end
	for key, tCurr in pairs(inMsg.Players) do
		if (tCurr~=nil) then
			if L_Saved_Settings.Seen[key]==nil or  L_Saved_Settings.Seen[key].LastSeen==nil then
				L_Saved_Settings.Seen[key]=tCurr
			else
				local t1=L_Saved_Settings.Seen[key].LastSeen
				local t2=tCurr.LastSeen
				if self:GetTimeValue(t1)<self:GetTimeValue(t2) then
					L_Saved_Settings.Seen[key]=tCurr
				end
			end
			if (inMsg.strCmd=="replySeen") then
				self:ShowKeyInfo(key,tCurr)
			end
		end
	end
	if L_Saved_Settings.Seen[inMsg.Author]==nil then
		L_Saved_Settings.Seen[inMsg.Author]={}
	end
	L_Saved_Settings.Seen[inMsg.Author].LastSeen=GameLib.GetServerTime()
	if (inMsg.Version==null) then
		inMsg.Version=1.1
	end
	L_Saved_Settings.Seen[inMsg.Author].LastSeen=GameLib.GetServerTime()
	L_Saved_Settings.Seen[inMsg.Author].Version=inMsg.Version
	L_Saved_Settings.Seen[inMsg.Author].VersionMinor=inMsg.VersionMinor
	L_Saved_Settings.Seen[inMsg.Author].F=inMsg.F
	L_Saved_Settings.Seen[inMsg.Author].L=inMsg.L
end
function GRB:ShowKeyInfo(key,tCurr)
	local factionString=""
	if tCurr.F~=nil then 
		if tCurr.F==166 then factionString="[D] " end
		if tCurr.F==167 then factionString="[E] " end
	end
	local levelString=""
	if tCurr.L~=nil then 
		levelString="["..tCurr.L.."] " 
	end
	local text=factionString..key..": "..tCurr.LastSeen.nDay.."."..tCurr.LastSeen.nMonth.."."..tCurr.LastSeen.nYear..".".." "..tCurr.LastSeen.strFormattedTime.." v="..tCurr.Version
	if (tCurr.VersionMinor) then
		text=text.."."..tCurr.VersionMinor
	end
	GRB:DebugOut(text)
end

function GRB:GetTimeValue(t)
	local tValue=t.nSecond+t.nMinute*60+t.nHour*3600+t.nDay*86400+t.nMonth*2678400+(t.nYear-2014)*977616000
	return tValue
end
function GRB:AskSeen()
	if not commChan then 
		GRB:DebugOut("Channel is not initialized...")
		return 
	end
	if not commChan:IsReady() then 
		GRB:DebugOut("Channel is not ready...")
		return 
	end
	local PlayerName= GameLib.GetPlayerUnit():GetName()
	if PlayerName==nil or type(PlayerName)~="string" then 
		GRB:DebugOut("Can't get player name...")
		return 
	end
	local tMsg={}
	tMsg.strCmd="getSeen"
	tMsg.Author=PlayerName
	local msg_encoded = JSON.encode(tMsg)
	GRB:DebugOut("Asking...")
	commChan:SendMessage(msg_encoded)
end
function GRB:ShowSeen()
	GRB:DebugOut("Seen:")
	if L_Saved_Settings==nil then 
		GRB:DebugOut("Settings not loaded...")
		return 
	end
	if L_Saved_Settings.Seen==nil then 
		GRB:DebugOut("Seen data is empty...")
		return 
	end
	local tempTable={}
	local idx=1
	for key, tCurr in pairs(L_Saved_Settings.Seen) do
		tempTable[idx]=tCurr
		tempTable[idx].key=key
		idx=idx+1
	end
	table.sort(tempTable,function(a,b) local ta=self:GetTimeValue(a.LastSeen) local tb=self:GetTimeValue(b.LastSeen) return ta<tb end)
	for key, tCurr in pairs(tempTable) do
		if (tCurr~=nil) then
			self:ShowKeyInfo(tCurr.key,tCurr)
		end
	end
end


function GRB:OnWindowManagementReady() --добавляемся в систему контроля окон от карбайнов (interfaceOptions)
	Event_FireGenericEvent("WindowManagementAdd", {wnd = self.wndMain, strName = "Горыныч: Настройки"})	
	--вот так-то, только после этого события мы можем нормально ловить хуки
	if Apollo.LoadForm~=ApolloLoadForm then
		GRB:RestoreLoadFormHandle()
	end
end


-----------------------------------------------------------------------------------------------
function L_Trace(why)
 if (why=="call") then
  GRB:TraceBefore()
  return
 end
 if (why=="return") then
  GRB:TraceAfter()
  return
 end
end

function GRB:SetHookFuncs() -- определяем перехватываемые функции
  -- Do not Trace
  L_TraceNot["L_Trace"]=true
  L_TraceNot["TraceAfter"]=true
  L_TraceNot["TraceBefore"]=true
  L_TraceNot["Print"]=true
  L_TraceNot["remove"]=true
  -- Trace Before
  
L_TraceAfter["fnOldLoadForm"]=true
end
function GRB:TraceBefore()
	local level = 3 -- lvl 3 так как вызывем из обработчика доп ф-ю
	local ok=false
        local info = debug.getinfo(level, "n") 

	local funcName=info.name
	local func=L_TraceBefore[funcName] -- получаем ссылку на обработчик функции
	if func==nil then return end --если мы ее не обрабатываем - выходим
	if L_TraceNot[funcName]~=nil then return end
	-- тут мы точно знаем что эту ф-ю надо обработать, проверяем правила перевода аддонов

	local infoFrom = GRB:GetAllDebugInfo(level+2)  --+1 потому что доп. вызов, и +1 потому что не вызываемую ф-ю смотрим а вызывающую

	local settings=L_Saved_Settings.Stub
	if infoFrom~=nil then -- код блокировки перевода аддонов и функций по настройкам
		local callerFuncName=infoFrom.funcName
		local callerAddonName=infoFrom.addonName

		if callerAddonName~=nil then
			local temp1=L_Saved_Settings.AddonsStock[callerAddonName]
			local temp2=L_Saved_Settings.AddonsUser[callerAddonName]
			if temp1~=nil then
				settings=temp1
			else 
				if temp2~=nil then
					settings=temp2
				end
			end
			if settings~=nil then -- если описано правило для аддона
				if settings.t~=1 then return end -- блокировка перевода в данном аддоне
				local funcs=settings.funcs
				if funcs~=nil then
					local funcSettings=funcs[callerFuncName]
					if funcSettings~=nil then
						settings=funcSettings
						if settings.t==0 then return end -- блокировка перевода в конкретной функции
					end
				end
			else -- если не описано правило для аддона
				return
			end
		end
		self:TB_ReplaceAddonLocalVariables(infoFrom) -- подмена локальных переменных
	end
    func(settings,infoFrom)
end
function GRB:TraceAfter()
    local level = 3 -- lvl 3 так как вызывем из обработчика доп ф-ю

    local ok=false
    local info = debug.getinfo(level, "n") -- http://www.lua.org/pil/23.1.html

    local funcName=info.name
	local func=L_TraceAfter[funcName] -- получаем ссылку на обработчик функции
	if func==nil then return end --если мы ее не обрабатываем - выходим
	if L_TraceNot[funcName]~=nil then return end

	local infoFrom = GRB:GetAllDebugInfo(level+2)  --+1 потому что доп. вызов, и +1 потому что не вызываемую ф-ю смотрим а вызывающую
	
	if (funcName=="fnOldLoadForm")  then -- обход для LibApolloFixes
		infoFrom = GRB:GetAllDebugInfo(level+3)
		funcName="LoadForm"
		func=L_TraceAfter[funcName] 
	end
 
	local settings=L_Saved_Settings.Stub
	if infoFrom~=nil then -- код блокировки перевода аддонов и функций по настройкам
		local callerFuncName=infoFrom.funcName
		local callerAddonName=infoFrom.addonName

		if callerAddonName~=nil then
			local temp1=L_Saved_Settings.AddonsStock[callerAddonName]
			local temp2=L_Saved_Settings.AddonsUser[callerAddonName]
			if temp1~=nil then
				settings=temp1
			else 
				if temp2~=nil then
					settings=temp2
				end
			end
			if settings~=nil then -- если описано правило для аддона
				if settings.t~=1 then return end -- блокировка перевода в данном аддоне
				local funcs=settings.funcs
				if funcs~=nil then
					local funcSettings=funcs[callerFuncName]
					if funcSettings~=nil then
						settings=funcSettings
						if settings.t==0 then return end -- блокировка перевода в конкретной функции
					end
				end
			else -- если не описано правило для аддона
				return
			end
		end
	end
    func(settings,infoFrom)
end
--============================== Trace Before Block ========================================-
function GRB:TB_ReplaceAddonLocalVariables(infoFrom)			------------------------------подмена локальных переменных ------------------------------------------
	if infoFrom.addonName==nil then return end
	if L_LOCALSREPLACE[infoFrom.addonName]~=nil then
		local variables = {}
		local idx = 1
		while true do
			local ln, lv = debug.getupvalue(infoFrom.func, idx)
			if ln ~= nil then
			  variables[ln] = lv
			  if L_LOCALSREPLACE[infoFrom.addonName][ln]~=nil then
				debug.setupvalue(infoFrom.func,idx,L_LOCALSREPLACE[infoFrom.addonName][ln])
			  end
			else
			  break
			end
			idx = 1 + idx
		end
	end
end 									------------------------------конец подмены локальных переменных-------------------------------------
L_TraceBefore["GetTextWidth"]=function(settings,infoFrom)
	local level=4
	if (infoFrom.funcName~="OnInteractiveUnitChanged") then return end
	--сначала правим текст
	if (settings.t==nil) or (settings.t==1) then
		local name,val = debug.getlocal(level, 2) 
		if (val~=nil) and (type(val)=="string") then 
			local strRU=GRB:TranslateString(val)
			if strRU~=nil then
				debug.setlocal(level,2,strRU) --замена переменных
			end
		end
	end
end
L_TraceBefore["ReplaceLineBreaks"]=function(settings,infoFrom)
	local level=4
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local name,val = debug.getlocal(level, 2) 
	if (val==nil) then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end	
end
L_TraceBefore["ShowTextFloater"]=function(settings,infoFrom)
	local level=4
	--ShowTextFloater( unitTarget, strMessage, tTextOption )
	--CombatFloater.ShowTextFloater( unitTarget, nDamage, nShieldDamaged, tTextOption )
	--сначала правим текст
	if (settings.t==nil) or (settings.t==1) then
		local name,val = debug.getlocal(level, 2) 
		if (val~=nil) and (type(val)=="string") then 
			--GRB:DebugOut("ShowTextFloater TEXT="..val) --12345
			local strRU=GRB:TranslateString(val)
			if strRU~=nil then
				--GRB:DebugOut("ShowTextFloater "..val.."="..strRU) --12345
				debug.setlocal(level,2,strRU) --замена переменных
			end
		end
	end
	--потом правим шрифт
	if (settings.f==nil) or (settings.f==1) then
		local textOptionsName,textOptionsVal = debug.getlocal(level, 3) 
		if (textOptionsVal~=nil) and (type(textOptionsVal)=="table") and (textOptionsVal.strFontFace~=nil) then
			local newFont=L_FONTS[textOptionsVal.strFontFace]
			--GRB:DebugOut("ShowTextFloater Font="..textOptionsVal.strFontFace) --12345
			if newFont~=nil then
				local fScale=L_FLOATSCALE[textOptionsVal.strFontFace]
				if (fScale~=nil) then
					--масштабируем шрифт
					textOptionsVal.fScale=textOptionsVal.fScale*fScale
					--масштабируем анимацию
					if (textOptionsVal.arFrames~=nil) then
						for key, tCurr in pairs(textOptionsVal.arFrames) do
							if (tCurr.fScale~=nil) then
								tCurr.fScale=tCurr.fScale*fScale
							end
						end --for
					end
				end
				--GRB:DebugOut("ShowTextFloater "..textOptionsVal.strFontFace.."="..newFont) --12345
				textOptionsVal.strFontFace=newFont
			
				debug.setlocal(level,3,textOptionsVal) --замена переменных
			end
		end
	end
end
L_TraceBefore["RequestShowTextFloater"]=function(settings,infoFrom) -- вывод названий локаций
	if (settings.f~=nil) and (settings.f==0) then return end --выход если перевод отключен
	local level=4
    local name,val = debug.getlocal(level, 5) 
	if name==nil or val==nil then return end
	local strFont=val.strFontFace
	if strFont==nil then return end
	
	--local nameText,valText = debug.getlocal(level, 4) --12345
	--GRB:DebugOut("RequestShowTextFloater text="..valText) --12345
	--GRB:DebugOut("RequestShowTextFloater Font="..strFont) --12345
	
	local strFont=L_FONTS[strFont]
	if strFont==nil then return end
	val.strFontFace=strFont
	--GRB:DebugOut("RequestShowTextFloater NEW Font="..strFont) --12345
	debug.setlocal(level,5,val)
end

L_TraceBefore["AddRegion"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val = debug.getlocal(level, 7) 
	if type(val)~="string" then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,7,strRU) --замена переменных
	end
end
L_TraceBefore["format"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	if (L_BlockedFuncsInformat[infoFrom.funcName]~=nil) then return end
	local level=4
	local nups=1
	while true do
		local name,val = debug.getlocal(level, nups) 
		if (name~=nil) then
			if val~=nil then
				if type(val)=="string" then
					local strRU=GRB:TranslateString(val)
					if strRU~=nil then
						--GRB:DebugOut("Formatting val#"..nups.." src="..val.." strRU="..strRU)
						if (settings.t==nil) or (settings.t==1) then
							debug.setlocal(level,nups,strRU) --замена переменных
						end
					else
						if (settings.f==nil) or (settings.f==1) then
							if L_FONTS[val]~=nil then --подмена шрифтов для string.format
								debug.setlocal(level,nups,L_FONTS[val]) --замена переменных
							end
						end
					end
				end
			end
			nups=nups+1
		else
		  break;
		end
	end	 
end
L_TraceBefore["String_GetWeaselString"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	if (L_BlockedFuncsInString_GetWeaselStringHandler[infoFrom.funcName]~=nil) then return end
	--перебор всех передаваемых параметров и замена всех передаваемых строк
	local level=4
	local nups=1
	local variables={}
	while true do
		local name,val = debug.getlocal(level, nups) 
		if (name~=nil) then
			if val~=nil then
				if type(val)=="string" then
					local strRU=GRB:TranslateString(val)
					if strRU~=nil then
						if (variables["Сервер: $1n"]==nil) then
							debug.setlocal(level,nups,strRU) --замена переменных
						end
					end	
					variables[val]=true
				end
			end
			nups=nups+1
		else
		  break;
		end
	end	 

end
L_TraceBefore["SetAML"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	--перебор всех передаваемых параметров и замена всех передаваемых строк
	local level=4
	local wndName=nil
	local nWnd,vWnd = debug.getlocal(level, 1) --получаем хэндл окна
	if (vWnd~=nil) then
		wndName=vWnd:GetName() --имя окна
	end
	
	local nups=1
	local strRU=nil
	while true do
		local name,val = debug.getlocal(level, nups) 
		if (name~=nil) then
			if val~=nil then
				if type(val)=="string" then
					if wndName~=nil and wndName~="" then
						strRU=GRB:TranslateControlByName(wndName,val,settings)
					 else --если окно не имеет имени
 						if (settings.t==nil) or (settings.t==1) then
							strRU=GRB:TranslateString(val)
						end
					 end
					if strRU~=nil then
						debug.setlocal(level,nups,strRU) --замена переменных
					end
				end
			end
			nups=nups+1
		else
		  break;
		end
	end
	
end
L_TraceBefore["SetText"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	if (L_BlockedFuncsInSetText[infoFrom.funcName]~=nil) then return end	
	local level=4
    local name,val = debug.getlocal(level, 2) 
    if (val==nil) then return end
	if type(val)~="string" then return end
	
	------------------ отключаем перевод имени сервера для почты -------------------
		local callerFuncName=infoFrom.funcName
		local callerAddonName=infoFrom.addonName
		if (callerAddonName=="mail") and (callerFuncName=="Init") then return end
	-------------------------------------------------------------------------------
	  -- тут на 3 лвл есть 3 переменных userdata,string,table
	  -- предположим что userdata это окно для которого производится вызов
	local strRU=nil
	local wndName=nil
	local nWnd,vWnd = debug.getlocal(level, 1) --получаем хэндл окна
	if (vWnd~=nil) then
		wndName=vWnd:GetName() --имя окна
	 end
	if wndName~=nil and wndName~="" then
		strRU=GRB:TranslateControlByName(wndName,val,settings)
	 else --если окно не имеет имени
		if (settings.t==nil) or (settings.t==1) then
			strRU=GRB:TranslateString(val)
		end
	 end
	 --если есть перевод - записываем
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end	
end
L_TraceBefore["SetTooltip"]=L_TraceBefore["SetText"]
L_TraceBefore["SetFont"]=function(settings,infoFrom)
	if (settings.f~=nil) and (settings.f==0) then return end --выход если перевод отключен
	local level=4
    local name,val = debug.getlocal(level, 2) 
    if (val==nil) then return end
	if type(val)~="string" then return end
	if L_FONTS[val]~=nil then
		debug.setlocal(level,2,L_FONTS[val])
	end
end

L_TraceBefore["PostOnChannel"]=function(settings,infoFrom) -- сообщения чата
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nCnannel,vChannel = debug.getlocal(level, 1) 
	local nText,vText = debug.getlocal(level, 2) 
	if nCnannel==nil or nText==nil then return end
	local ok=false
	ok=ok or (vChannel==ChatSystemLib.ChatChannel_Loot)
	ok=ok or (vChannel==ChatSystemLib.ChatChannel_System)
	ok=ok or ChatSystemLib.ChatChannel_Emote
	ok=ok or ChatSystemLib.ChatChannel_AnimatedEmote
	ok=ok or ChatSystemLib.ChatChannel_NPCSay
	ok=ok or ChatSystemLib.ChatChannel_NPCYell
	ok=ok or ChatSystemLib.ChatChannel_NPCWhisper
	ok=ok or ChatSystemLib.ChatChannel_Datachron
	ok=ok or ChatSystemLib.ChatChannel_Combat
	if not ok then return end
	if vText==null then return end
	--GRB:DebugOut("TBPostOnChannel="..vText)
	local strRU=GRB:TranslateString(vText)
	if (strRU~=nil) then
		debug.setlocal(level,2,strRU) --замена переменных
	end
	
end
L_TraceBefore["BuildRosterList"]=function(settings,infoFrom) -- ростер гильдии
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nRoster,tRoster = debug.getlocal(level,3) 
	if (nRoster==nil) or (tRoster==nil) then return end
	for key, tCurr in pairs(tRoster) do
		if (tCurr.strClass~=nil) then
			tRoster[key].strClass=GRB:TranslateStringOrReturnSame(tCurr.strClass);
		end
	end
	debug.setlocal(level,3,tRoster)
end
L_TraceBefore["AddLine"]=function(settings,infoFrom) -- для тултипов в хаузинге
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nLine,tLine = debug.getlocal(level,2) 
	if (nLine==nil) or (tLine==nil) then return end
	local strRU=GRB:TranslateString(tLine)
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end	
end
L_TraceBefore["SpawnAndDrawColReader"]=function(settings,infoFrom) --тексты датакубов
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,tArticleData = debug.getlocal(level,2) 
	if (tArticleData==nil) then return end
	local strText=tArticleData.strText
	if strText~=nil then
		--GRB:DebugOut("ArticleText="..strText)
		local strRU=GRB:TranslateStringOrReturnSame(strText)
		--GRB:DebugOut("strRU="..strRU)
		tArticleData.strText=strRU
		debug.setlocal(level,2,tArticleData) 
	end
end
L_TraceBefore["ItemTooltipHeaderHelper"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name2,val2 = debug.getlocal(level,2) 
	--SendVarToRover("item tooltip",val2,0)
	if (val2~=nil) and (type(val2)=="table") and (val2.strNameOriginal~=nil) then
		local origName="<P Font=\"CRB_Pixel\" >"..val2.strNameOriginal.."</P>"
		val2.strName=val2.strName.."\n"..origName
		debug.setlocal(level,2,val2)
	end
end

---------------- Trace After Block -------------------------------------
L_TraceAfter["GetData"]=function(settings,infoFrom) 
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local callerFuncName=infoFrom.funcName
	local callerAddonName=infoFrom.addonName
	if callerFuncName=="OnAugmentationTooltip" then
		--AMP data for Tooltips
		local level=4
		local name,val=debug.getlocal(level,2)
		if val~=nil and val.nSpellIdAugment~=nil and val.translated==nil then
			local ok=true
			if (val.nId~=nil) then
				if (val.nId==937) or (val.nId==938) or (val.nId==939) or (val.nId==940) or (val.nId==941) or (val.nId==942) or (val.nId==680) then
					--у этих спеллов есть измененный для ампов дескрипшн, который лежит в таблице EldanAugmentation
					ok=false
				end
			end
			local spellInfo=L_Spells[val.nSpellIdAugment]
			if ok and (spellInfo~=nil) and (spellInfo.localizedTextIdName~=nil) then
				--берем из базы спеллов инфу
				local strRUDesc=spellInfo.localizedTextIdActionBarTooltip
				local strRUName=spellInfo.localizedTextIdName 
				local origName=spellInfo.localizedTextIdName_e or ""
				
				if strRUName~=nil and strRUDesc==nil then
					strRUDesc=val.strDescription or ""
				end
				-- strRUDesc всегда не null
				if strRUName~=nil then
					--add orig.name to description
					strRUDesc=String_GetWeaselString(strRUDesc)
					strRUDesc="</P> <P TextColor=\"UI_TextHoloTitle\" Font=\"CRB_InterfaceSmall\">"..origName.."</P>\n".."<P TextColor=\"UI_TextHoloBody\" Font=\"CRB_InterfaceSmall\">"..strRUDesc
				end
				if (strRUName~=nil) then
					val.strTitle=strRUName
				end
				val.strDescription=strRUDesc
				val.translated=true
				debug.setlocal(level,2,val)
			end
		end			
	end -- end of OnAugmentationTooltip
end

L_TraceAfter["GetVitalTable"]=function(settings,infoFrom) 
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,val=debug.getlocal(level,1)
	if (val==nil) then return end
	for idx, vital in ipairs(val) do
		if vital.strName~=nil then
			local strRU=GRB:TranslateString(vital.strName)
			if strRU~=nil then
				val[idx].strName=strRU
			end		
		end
	end	
	debug.setlocal(level,1,val)
end
L_TraceAfter["GetCostInfoString"]=function(settings,infoFrom) -- в ампах, часть спеллов имеет кастомные строки стоимости, можно посмотреть у спеллсингера руны исцеления и жизненные силы
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local nameSpell,valSpell=debug.getlocal(level,1)
	local nameStr,valStr=debug.getlocal(level,2)
	if valStr==nil then return end
	if valSpell==nil then return end
    if type(valStr) ~= "string" then return end
	local strRU=GRB:TranslateString(valStr)
	
	local isSpell=false
	if valSpell~=nil then
		if (valSpell.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	
	if isSpell then
		local spellInfo=L_Spells[valSpell:GetId()]
		if (spellInfo~=nil)  then
			--берем из базы спеллов инфу
			strRU=spellInfo.localizedTextIdTooltipCostInfo
			if strRU~=nil then
				strRU=String_GetWeaselString(strRU)
			end
		end
	end	
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end			
	
end
L_TraceAfter["GetTalesForZone"]=function(settings,infoFrom) --lore
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,val=debug.getlocal(level,2)
	if (val~=nil) then
	
		for idx, cube in ipairs(val) do
			if cube.strText~=nil then
				local strRU=GRB:TranslateString(cube.strText)
				if strRU~=nil then
					val[idx].strText=strRU
				end		
			end
			if cube.strTitle~=nil then
				local strRU=GRB:TranslateString(cube.strTitle)
				if strRU~=nil then
					val[idx].strTitle=strRU
				end		
			end
		end	
		debug.setlocal(level,2,val)
	end
end
L_TraceAfter["GetDatacubesForZone"]=function(settings,infoFrom) --lore
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,val=debug.getlocal(level,2)
	if (val~=nil) then
	
		for idx, cube in ipairs(val) do
			if cube.strText~=nil then
				local strRU=GRB:TranslateString(cube.strText)
				if strRU~=nil then
					val[idx].strText=strRU
				end		
			end
			if cube.strTitle~=nil then
				local strRU=GRB:TranslateString(cube.strTitle)
				if strRU~=nil then
					val[idx].strTitle=strRU
				end		
			end
		end	
		debug.setlocal(level,2,val)
	end
end
L_TraceAfter["GetJournalsForZone"]=function(settings,infoFrom) --lore
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,cube=debug.getlocal(level,2)
	if (cube~=nil) then
		if cube.strTitle~=nil then
			local strRU=GRB:TranslateString(cube.strTitle)
			if strRU~=nil then
				cube.strTitle=strRU
			end		
		end
		if cube.strText~=nil then
			local strRU=GRB:TranslateString(cube.strText)
			if strRU~=nil then
				cube.strText=strRU
			end		
		end
		debug.setlocal(level,2,cube)
	end
end
L_TraceAfter["GetLastUpdatedDatacube"]=function(settings,infoFrom) --lore
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,val=debug.getlocal(level,2)
	if (val~=nil) then
		debug.setlocal(level,2,val)
	end
end
L_TraceAfter["GetSchematicList"]=function(settings,infoFrom) --крафт
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,tSchematicList=debug.getlocal(level,5)
	if (tSchematicList~=nil) then
		local changed=false
		for idx, tCurrSchematic in pairs(tSchematicList) do
			local tSchematicInfo = CraftingLib.GetSchematicInfo(tCurrSchematic.nSchematicId)
				if (tSchematicInfo~=nil) and (tSchematicInfo.itemOutput~=nil) then
				local itemId=tSchematicInfo.itemOutput:GetItemId()
				-- если есть перевод итема
				if (L_Items[itemId]~=nil) then
					local strRU=nil
					-- если есть общий перевод итема
					if (L_Items[itemId].a~=nil) then
						strRU=L_Items[itemId].a
					else
						--если есть перевод итема в единственном числе 
						if L_Items[itemId].o~=nil then
							strRU=L_Items[itemId].o
						end
					end
					if strRU~=nil then
						tSchematicList[idx].strName=strRU
						changed=true
					end
				end		
			end
		end
		if changed then 
			debug.setlocal(level,5,tSchematicList)
		end
	end
end
L_TraceAfter["GetSchematicInfo"]=function(settings,infoFrom) --крафт
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,tSchematicInfo=debug.getlocal(level,2)
	if (tSchematicInfo~=nil) and (tSchematicInfo.itemOutput~=nil) then
		local itemId=tSchematicInfo.itemOutput:GetItemId()
		-- если есть перевод итема
		if (L_Items[itemId]~=nil) then
			local strRU=nil
			-- если есть общий перевод итема
			if (L_Items[itemId].a~=nil) then
				strRU=L_Items[itemId].a
			else
				--если есть перевод итема в единственном числе 
				if L_Items[itemId].o~=nil then
					strRU=L_Items[itemId].o
				end
			end
			if strRU~=nil then
				tSchematicInfo.strName=strRU
				debug.setlocal(level,2,tSchematicInfo)
			end
		end		
	end

end
L_TraceAfter["GetVendorGroups"]=function(settings,infoFrom) -- корректная отрисовка репутаций
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,tVendorGroups=debug.getlocal(level,2)
	--код для выгрузки таблиц вендора
	--L_Saved_Settings.tVendorGroups=tVendorGroups
end
L_TraceAfter["GetReputationLevels"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,tReputationLevels=debug.getlocal(level,1)
	if (type(tReputationLevels)=="table") then
		if tReputationLevels[1].nMin==0 then tReputationLevels[1].strName=L_Interface["FactionReputationLevel_Neutral"] end
		if tReputationLevels[2].nMin==2000 then tReputationLevels[2].strName=L_Interface["FactionReputationLevel_Liked"] end
		if tReputationLevels[3].nMin==4000 then tReputationLevels[3].strName=L_Interface["FactionReputationLevel_Accepted"] end
		if tReputationLevels[4].nMin==8000 then tReputationLevels[4].strName=L_Interface["FactionReputationLevel_Popular"] end
		if tReputationLevels[5].nMin==16000 then tReputationLevels[5].strName=L_Interface["FactionReputationLevel_Esteemed"] end
		if tReputationLevels[6].nMin==32000 then tReputationLevels[6].strName=L_Interface["FactionReputationLevel_Beloved"] end
		debug.setlocal(level,1,tReputationLevels)
	end
end
L_TraceAfter["GetSlotName"]=function(settings,infoFrom) -- character 585 string fix
	--фикс characterpanel 585 строка

	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,val=debug.getlocal(level,2)
    --local name,item=debug.getlocal(level,1)
	--SendVarToRover("item",item,0)
    if (val==nil) then return end
    if type(val) ~= "string" then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end	
end
L_TraceAfter["TEMP_SingleStringReturn1"]=function(settings,infoFrom) -- просто перевод возвращаемой строки -кол-во параметров=1
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local nParam=1
	local level=4
    local name,val=debug.getlocal(level,nParam)
    if (val==nil) then return end
    if type(val) ~= "string" then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,nParam,strRU) --замена переменных
	end	
end

L_TraceAfter["TEMP_SingleStringReturn2"]=function(settings,infoFrom) -- просто перевод возвращаемой строки -кол-во параметров=2
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local nParam=2
	local level=4
    local name,val=debug.getlocal(level,nParam)
    if (val==nil) then return end
    if type(val) ~= "string" then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,nParam,strRU) --замена переменных
	end	
end
L_TraceAfter["GetDesc"]=L_TraceAfter["TEMP_SingleStringReturn2"]
L_TraceAfter["GetWorldZoneName"]=L_TraceAfter["TEMP_SingleStringReturn2"]
L_TraceAfter["GetSubZoneName"]=L_TraceAfter["TEMP_SingleStringReturn2"]
--матчмакер
L_TraceAfter["GetDescription"]=L_TraceAfter["TEMP_SingleStringReturn2"]
L_TraceAfter["GetRecommendedItemLevel"]=L_TraceAfter["TEMP_SingleStringReturn2"]


L_TraceAfter["GetName"]=function(settings,infoFrom) 
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local nParam=2
	local level=4
    local name,val=debug.getlocal(level,nParam)

    if (val==nil) then return end
    if type(val) ~= "string" then return end
	local strRU=GRB:TranslateString(val)
	
	local nameObj,valObj=debug.getlocal(level,1) --берем объект, у которого вызывается данный метод
	local isSpell=false
	if valObj~=nil then
		if (valObj.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	if isSpell then
		local spellInfo=L_Spells[valObj:GetId()]
		if (spellInfo~=nil) and (spellInfo.localizedTextIdName~=nil) then
			--берем из базы спеллов инфу
			strRU=spellInfo.localizedTextIdName

			--if (strRU=="Дорожный марш") then --12345
			--SendVarToRover("from",infoFrom,0)
			--end
			--надо отключить ориг. название для баффов
			--и вообще ориг. названия только для тултипов делаем
			if (spellInfo.localizedTextIdName_e~=nil) and (infoFrom.addonName=="tooltips") and (not string.match(infoFrom.name, "Buff")) then
				local origName="<P Font=\"CRB_Pixel\" >"..spellInfo.localizedTextIdName_e.."</P>"
				strRU=strRU.." \n"..origName
			end
		else --если перевели не по базе спеллов - все равно надо англ. подпись бы подставить
			--надо отключить ориг. название для баффов
			if (strRU~=nil) and (infoFrom.addonName=="tooltips") and (not string.match(infoFrom.name, "Buff")) then
				local origName="<P Font=\"CRB_Pixel\" >"..val.."</P>"
				strRU=strRU.." \n"..origName
			end
		end
	end	
	
	
	if strRU~=nil then
		debug.setlocal(level,nParam,strRU) --замена переменных
	end		
end
L_TraceAfter["GetAffiliationName"]=L_TraceAfter["TEMP_SingleStringReturn2"]
L_TraceAfter["GetNPCText"]=function(settings,infoFrom) 
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name,val=debug.getlocal(level,nups-1)
	if val==nil then return end
	if type(val)~="string" then return end
	local strRU;
	--SendVarToRover("GetNPCText: "..val,name,0)
	--SendVarToRover("GetNameObjName: "..val,objName,0)
	strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,nups-1,strRU) --замена переменных
	end
end
L_TraceAfter["GetString"]=function(settings,infoFrom) -- берет строку из таблицы интерфейса
	if not useTAGetStringHandler then return end
	--фиксим пропавшие кнопочки из нижнего меню
	--цена починки - англ. имена кнопок, потому что всякие strtolower и т.д. не работают с русскими
	--смотреть сюда function InterfaceMenuList:OnNewAddonListed(strKey, tParams)
	--if infoFrom.funcName~=nil and infoFrom.funcName=="OnInterfaceMenuListHasLoaded"  then
	--	return
	--end
	if (settings.t~=nil) and (settings.t==0) then return end
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,strId=debug.getlocal(level,1)
	
    local name,val=debug.getlocal(level,nups-1)
	if val==nil then return end
	if type(val)~="string" then return end
	
	local strRU=nil
	if L_Interface[strId]~=nil then
		strRU=L_Interface[strId]
	else
		strRU=GRB:TranslateString(val)
	end
    if strRU~=nil then
		debug.setlocal(level,nups-1,strRU) --замена переменных
	end
end


L_TraceAfter["GetObjectiveShortDescription"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,var=debug.getlocal(level,1)
    local name0,objId=debug.getlocal(level,2)
	--local name,objShort=debug.getlocal(level,nups-1)
	if (type(var)~="userdata") or (not Quest.is(var)) then
		return
	end
	local qId=var:GetId()
	if L_Quests[qId]==null then return end
	local db_o=L_Quests[qId].o
	for db_oName,db_oValue in pairs(db_o) do
		if db_oValue.i==objId then
			if db_oValue.s~=nil and db_oValue.s>"" then
				debug.setlocal(level,nups-1,String_GetWeaselString(db_oValue.s))
			end	
		end
	end
end
L_TraceAfter["GetVisibleObjectiveData"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,var=debug.getlocal(level,1)
	local name,q_o=debug.getlocal(level,nups-1)
	if (type(var)~="userdata") or (not Quest.is(var)) then
		return
	end
	--SendVarToRover("quest id="..var:GetId(),var,1)	
	local qId=var:GetId()
	if L_Quests[qId]==null then return end
	local db_o=L_Quests[qId].o
	--тут правим обжективы, сначала промежуточные
	local changed=false
	for q_oName,q_oValue in pairs(q_o) do
		local nIndex=q_oValue.nIndex
		for db_oName,db_oValue in pairs(db_o) do
			--если это ревард
			if db_oValue.bIsReward then
				if (L_Quests[qId].localizedTextIdCompletionOverride~=nil) then
					q_oValue.strDescription=String_GetWeaselString(L_Quests[qId].localizedTextIdCompletionOverride)
					changed=true
				end
			else
				--если это не ревард
				if db_oValue.i==nIndex then
					--если есть перевод на этот обжектив
					if db_oValue.f~=nil and db_oValue.f>"" then
						q_oValue.strDescription=String_GetWeaselString(db_oValue.f)
						changed=true
					end
				end
			end
		end
	end	
	if changed then
		debug.setlocal(level,nups-1,q_o)
	end
	--тут правим ревард обжективы
	
	
end
L_TraceAfter["GetCompletionObjectiveShortText"]=function(settings,infoFrom)
	 -- Обрабатываем квесты, потом еще надо будет обработать эпизоды
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,var=debug.getlocal(level,1)
	local strRU;
	if (type(var)=="userdata") and (Quest.is(var))
	then
		strRU=GRB:GetQuestAttribute(var:GetId(),"CompletionObjectiveShortText")
		if strRU~=nil then
			debug.setlocal(level,nups-1,strRU) --замена переменных
			return
		end
	end
end
L_TraceAfter["GetCompletionObjectiveText"]=function(settings,infoFrom)
	 -- Обрабатываем квесты, потом еще надо будет обработать эпизоды
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,var=debug.getlocal(level,1)
	local strRU;
	if (type(var)=="userdata") and (Quest.is(var))
	then
		strRU=GRB:GetQuestAttribute(var:GetId(),"CompletionObjectiveText")
		if strRU~=nil then
			debug.setlocal(level,nups-1,strRU) --замена переменных
			return
		end
	end
end
L_TraceAfter["GetSummary"]=function(settings,infoFrom)
	 -- Обрабатываем квесты, потом еще надо будет обработать эпизоды
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,var=debug.getlocal(level,1)
    local name,val=debug.getlocal(level,nups-1)
	if val==nil then return end
	if type(val)~="string" then return end
	local strRU;
	if (type(var)=="userdata") and (Quest.is(var))
	then
		strRU=GRB:GetQuestAttribute(var:GetId(),"Summary")
		if strRU~=nil then
			debug.setlocal(level,nups-1,strRU) --замена переменных
			return
		end
	end
end
L_TraceAfter["GetCompletedSummary"]=function(settings,infoFrom)
     -- Обрабатываем квесты
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
	
    local name0,var=debug.getlocal(level,1)

    local name,val=debug.getlocal(level,nups-1)
	if val==nil then return end
	if type(val)~="string" then return end
	local strRU;
	if (type(var)=="userdata") and (Quest.is(var))
	then
		strRU=GRB:GetQuestAttribute(var:GetId(),"CompletedSummary")
		if strRU~=nil then
			debug.setlocal(level,nups-1,strRU) --замена переменных
			return
		end
	end
end

L_TraceAfter["GetTutorial"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
    local name,val=debug.getlocal(level,2)
	if val==nil then return end
	for idx, page in ipairs(val) do
		for idx, strCurrText in ipairs(page.tBody) do
			if strCurrText~=nil then
				local strRU=GRB:TranslateString(strCurrText)
				if strRU~=nil then
					page.tBody[idx]=strRU
				end		
			end	
		end	
		val[idx]=page
	end
	debug.setlocal(level,2,val) --замена переменных	
end
L_TraceAfter["GetTitle"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	--отключаем перевод для ГА сортировки по буквам
	--SendVarToRover("infoFrom",infoFrom,0)
	if (infoFrom~=nil) and (infoFrom.addonName~=nil) and (infoFrom.addonName=="galacticarchive") then 
		return
	end
	local level=4
	local index=2
    local name,val=debug.getlocal(level,index)
	if val==nil then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,index,strRU) --замена переменных
	end	
end
L_TraceAfter["GetTitleOrName"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local index=2
    local name,val=debug.getlocal(level,index)
    --local name2,valUnit=debug.getlocal(level,index-1)
	if val==nil then return end
	--if (valUnit~=nil) and (valUnit:HasTitle()) then
		-- не хочу делать потому что просядет производительность
		--local Name=valUnit:GetName()
		--local Title=val:gsub(Name, "")
	--end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,index,strRU) --замена переменных
	end	
end
L_TraceAfter["GetMoreInfoText"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name0,strId=debug.getlocal(level,1)
    local name,tMoreInfoText=debug.getlocal(level,nups-1)
	if tMoreInfoText==nil then return end
	if #tMoreInfoText > 0 then
		for idx, tValues in pairs(tMoreInfoText) do
			tValues.strSay=GRB:TranslateStringOrReturnSame(tValues.strSay)
			tValues.strResponse=GRB:TranslateStringOrReturnSame(tValues.strResponse)
			tMoreInfoText[idx]=tValues
		end
		
	end
	debug.setlocal(level,nups-1,tMoreInfoText) --замена переменных
end
L_TraceAfter["SetText"]=function(settings,infoFrom)
	if (settings.f~=nil) and (settings.f==0) then return end --выход если перевод отключен
	if (L_BlockedFuncsInSetText[infoFrom.funcName]~=nil) then return end
	local level=4
	  -- тут на 4 лвл есть 3 переменных userdata,string,table
	  -- предположим что userdata это окно для которого производится вызов
	local nups=0
	while true do
		local name,wnd = debug.getlocal(level, nups+1) 
		if (name~=nil) then
			if (wnd~=nil) then 
				if (type(wnd)=="userdata") then
				   local wndFont=wnd:GetFont()
				   if (wndFont~=nil) and (L_FONTS[wndFont]~=nil) then
					 wnd:SetFont(L_FONTS[wndFont])
				   end
				   
				   --старый способ GRB:SetWindowFont(wnd)
				end
			end
			nups=nups+1
		else
		  break;
		end
	end
end
L_TraceAfter["GetObjectsAt"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end
	local name,tMapObjects = debug.getlocal(level,nups-1) 
	if (tMapObjects==nil) then return end
	for key, tObject in pairs(tMapObjects) do
		local strName=tObject.strName
		if strName~=nil then
			strName=GRB:TranslateStringOrReturnSame(strName)
			tMapObjects[key].strName=strName
		end	
	end
	debug.setlocal(level,nups-1,tMapObjects) 
end
--housing
L_TraceAfter["GetDecorList"]=function(settings,infoFrom) --GRB:TAGetDecorList
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end
	local name,tItemList = debug.getlocal(level,nups-1) 
	if (tItemList==nil) then return end
	for idx = 1, #tItemList do
		local strName = tItemList[idx].strName
		if strName~=nil then
			strName=GRB:TranslateStringOrReturnSame(strName)
			tItemList[idx].strName=strName
		end	
	end
	debug.setlocal(level,nups-1,tItemList) 
end
L_TraceAfter["GetDecorListWarplot"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetPlacedDecorListWarplot"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetPlacedDecorList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetDecorCrateListWarplot"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetDecorCrateList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetDecorTypeListWarplot"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetDecorTypeList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetRemodelRoofList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetRemodelWallpaperInteriorList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetRemodelWallpaperExteriorList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetRemodelEntryList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetRemodelDoorList"]=L_TraceAfter["GetDecorList"]
L_TraceAfter["GetRemodelSkyExteriorList"]=L_TraceAfter["GetDecorList"]
--end housing

L_TraceAfter["GetTooltips"]=function(settings,infoFrom) --spell
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,2)
	if val==nil then return end
	local nameObj,valObj=debug.getlocal(level,1) --берем объект, у которого вызывается данный метод
	local isSpell=false

	if valObj~=nil then
		if (valObj.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	if isSpell then
		local spellInfo=L_Spells[valObj:GetId()]
		if spellInfo==nil then return end
		--val:
		--strCasterTooltip
		--strLASTooltip
		--strPrimaryTargetTooltip
		--strSecondaryTargetTooltip
		local changed=false
		if spellInfo.localizedTextIdPrimaryTargetIconSpellText~=nil then
			val.strPrimaryTargetTooltip=String_GetWeaselString(spellInfo.localizedTextIdPrimaryTargetIconSpellText)
			changed=true
		end
		if spellInfo.localizedTextIdSecondaryTargetIconSpellText~=nil then
			val.strSecondaryTargetTooltip=String_GetWeaselString(spellInfo.localizedTextIdSecondaryTargetIconSpellText)
			changed=true
		end
		if spellInfo.localizedTextIdCasterIconSpellText~=nil then
			val.strCasterTooltip=String_GetWeaselString(spellInfo.localizedTextIdCasterIconSpellText)
			changed=true
		end
		if spellInfo.localizedTextIdActionBarTooltip~=nil then
			-- вот такая вот бля логика карбинов
			val.strLASTooltip=String_GetWeaselString(spellInfo.localizedTextIdActionBarTooltip)
			changed=true
		end
--		if spellInfo.localizedTextIdLASTierPoint~=nil then
--			val.strLASTooltip=String_GetWeaselString(spellInfo.localizedTextIdLASTierPoint)
--			changed=true
--		end
		if changed then
			debug.setlocal(level,2,val) --замена переменных
		end
	end
	
end
L_TraceAfter["GetFlavor"]=function(settings,infoFrom) --spell
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,2)
	if val==nil then return end
	if type(val)~="string" then return end
	local nameObj,valObj=debug.getlocal(level,1) --берем объект, у которого вызывается данный метод
	
	local isSpell=false
	if valObj~=nil then
		if (valObj.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	local strRU=nil
	if isSpell then
		local spellInfo=L_Spells[valObj:GetId()]
		if spellInfo==nil then return end
		strRU=spellInfo.localizedTextIdActionBarTooltip
		if strRU~=nil then strRU=String_GetWeaselString(strRU) end
	else
		strRU=GRB:TranslateSpell(val,settings)
	end
	
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end
end
L_TraceAfter["GetLasTierDesc"]=function(settings,infoFrom) --spell
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,2)
	if val==nil then return end
	if type(val)~="string" then return end
	local nameObj,valObj=debug.getlocal(level,1) --берем объект, у которого вызывается данный метод
	
	local isSpell=false
	if valObj~=nil then
		if (valObj.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	local strRU=nil
	if isSpell then
		local spellInfo=L_Spells[valObj:GetId()]
		if spellInfo==nil then return end
		strRU=spellInfo.localizedTextIdLASTier
		if strRU~=nil then strRU=String_GetWeaselString(strRU) end
	else
		strRU=GRB:TranslateSpell(val,settings)
	end
	
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end
end
L_TraceAfter["GetCastInfoString"]=function(settings,infoFrom) --spell
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,2)
	if val==nil then return end
	if type(val)~="string" then return end
	local nameObj,valObj=debug.getlocal(level,1) --берем объект, у которого вызывается данный метод
	
	local isSpell=false
	if valObj~=nil then
		if (valObj.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	local strRU=nil
	if isSpell then
		local spellInfo=L_Spells[valObj:GetId()]
		if spellInfo==nil then return end
		strRU=spellInfo.localizedTextIdTooltipCastInfo
		if strRU~=nil then strRU=String_GetWeaselString(strRU) end
	else
		strRU=GRB:TranslateSpell(val,settings)
	end
	

	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end
end
L_TraceAfter["GetLasBonusEachTierDesc"]=function(settings,infoFrom) --spell
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,2)
	if val==nil then return end
	if type(val)~="string" then return end
	local nameObj,valObj=debug.getlocal(level,1) --берем объект, у которого вызывается данный метод
	local isSpell=false
	if valObj~=nil then
		
		if (valObj.GetBaseSpellId~=nil) then --по наличию ф-ии определяем спелл это или нет
			isSpell=true
		end
	end
	local strRU=nil
	if isSpell then
		local spellInfo=L_Spells[valObj:GetId()]
		if spellInfo==nil then return end
		strRU=spellInfo.localizedTextIdLASTierPoint
		if strRU~=nil then strRU=String_GetWeaselString(strRU) end
	else
		strRU=GRB:TranslateSpell(val,settings)
	end

	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end
end
L_TraceAfter["GetItemCategoryName"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local nParam=2
	local level=4
    local name,val=debug.getlocal(level,nParam)

    if (val==nil) then return end
    if type(val) ~= "string" then return end
	local strRU=GRB:TranslateString(val)
	if strRU~=nil then
		debug.setlocal(level,nParam,strRU) --замена переменных
	end		
end
L_TraceAfter["GetItemTypeName"]=function(settings,infoFrom) --Get some string
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,2)
	if val==nil then return end
	if type(val)~="string" then return end
	local strRU=nil
	strRU=GRB:TranslateSpell(val,settings)
	if strRU~=nil then
		debug.setlocal(level,2,strRU) --замена переменных
	end
end
--смотри в начале аддона кусок, повторяющий код этого обработчика, изменять одновременно
L_TraceAfter["LoadForm"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	--при первом запуске восстанавливаем хэндл

	local level=4
	local info = debug.getinfo(level, "n")
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end
	local name=nil
	local loadedWindow=nil
	
	if (nups==6) then
		name,loadedWindow = debug.getlocal(level,nups-1) 
		--SendVarToRover("Nups6Test",loadedWindow,0)
	end
	if (nups==7) then
		name,loadedWindow = debug.getlocal(level,nups-2) 
		--SendVarToRover("Nups7Test",loadedWindow,0)
	end
	if (loadedWindow==nil) then return end
	local startIdx=1 -- обычно 1, но 
	if info.name=="LoadTooltipForm" then startIdx=2 end -- хрен его знает почему
	if info.name=="LoadTooltipFormSecondary" then startIdx=2 end -- хрен его знает почему

	local name2,xmlDoc=debug.getlocal(level,startIdx)  -- тут может быть или имя файла или объект xmlDoc
	if (xmlDoc==nil) then return end
	local fileName=nil
	if type(xmlDoc)=="string" then --первым параметром шло имя файла
		local path,file,extension = string.match(xmlDoc, "(.-)([^\\]-([^\\%.]+))$")
		fileName=string.upper(file)
	end
	if type(xmlDoc)=="userdata" then -- первым параметром шел xmlDoc
		fileName=LoadedXMLS[xmlDoc]
	end
	local name3,formName=debug.getlocal(level,startIdx+1) 
	if fileName=="LIVEEVENT.XML"  then
		-- вручную переводим окно эвента, т.к. оно не соответствует описанию в xml 
		if loadedWindow~=nil and loadedWindow:GetName()=="LiveEventMain" then
			loadedWindow:FindChild("LiveEventCashTitle"):SetFont("CRB_Interface11")
			local str_progress=L_Interface["ZoneCompletion_Progress"]
			if str_progress~=nil then
				loadedWindow:FindChild("LiveTabProgressBtn"):SetFont("CRB_Dialog")
				loadedWindow:FindChild("LiveTabProgressBtn"):SetText(str_progress)
			end
			local str_summary=L_Interface["Achievements_SummaryBtn"]
			if str_summary~=nil then
				loadedWindow:FindChild("LiveTabSummaryBtn"):SetFont("CRB_Dialog")
				loadedWindow:FindChild("LiveTabSummaryBtn"):SetText(str_summary)
			end
			
		end
		return -- выходим, отменяя стандартный перевод
	end
	if (type(loadedWindow)=="userdata") then
	    local wndDef=nil
		if L_FORMS~=nil and L_FORMS[fileName]~=nil and fileName~=nil then
			wndDef=L_FORMS[fileName]
			wndDef=wndDef[formName]
		end
		if (wndDef~=nil) and (useOldTranslatingMethodWithFormDefs) then
			--если найдено определение формы
			GRB:TranslateForm(wndDef,loadedWindow,1,settings)
		else 
			--если не найдено определение формы
			if (formName~=nil) and type(xmlDoc)=="userdata" then --переводим по шаблону xml
				--если хватает данных для перевода по новому методу
				if useNewTranslatingMethodWithoutFormDefs then
					--и если включен метод перевода по xml-источнику
					GRB:TranslateLoadedForm(xmlDoc,loadedWindow,formName,settings)
				end
			end
		end
	else
		--тут у нас loadedWindow не userdata
		--GRB:DebugOut("error parsing LoadForm data")
	end	
end
L_TraceAfter["LoadTooltipForm"]=L_TraceAfter["LoadForm"]
L_TraceAfter["LoadTooltipFormSecondary"]=L_TraceAfter["LoadForm"]
L_TraceAfter["CreateFromFile"]=function(settings,infoFrom) -- cохраняет имя файла для дальнейшей обработки в TALoadForm
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end
	local name,xmlDoc = debug.getlocal(level,nups-1) 

    if (xmlDoc==nil) then return end
	local name2,fileName=debug.getlocal(level,1) 
	if (type(xmlDoc)=="userdata") then
		LoadedXMLS[xmlDoc]=string.upper(fileName)
	end
end
L_TraceAfter["GetDetailedInfo"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local idx=3
	local found=false
	while true do
		local n,v = debug.getlocal(level, idx) 
		if (idx>0) then
			if type(v)=="table" and v.tPrimary~=nil then
				found=true
				break
			end
			idx=idx-1
		else
		  break;
		end
	end
	if (found~=true) then return end
	local name,tItemInfo = debug.getlocal(level,idx) 
	local newItemInfo=GRB:TranslateItem(tItemInfo)
	if newItemInfo~=nil then
		debug.setlocal(level,idx,tItemInfo) 
	end

end
L_TraceAfter["GetContactInfo"]=function(settings,infoFrom) --квестлог id candidate
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (n~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end
	local name,tContactInfo = debug.getlocal(level,nups-1) 
    if (tContactInfo==nil) then return end
	local changed=false
	local strName=tContactInfo.strName
	if strName~=nil then
		local strRU=GRB:TranslateStringOrReturnSame(strName)
		tContactInfo.strName=strRU
		changed=true
	end
	
	if changed then
		debug.setlocal(level,nups-1,tContactInfo) 
	end
  
end
L_TraceAfter["Show"]=function(settings,infoFrom) -- GRB:TAShow переводит формы, где строки указываются через хардкод - например AddRegion(self.eObjectTypeQuest, tObjRegions.nWorldZoneId, tObjRegions.tRegions, queCurr, tObjRegions.tIndicator, tostring(nQuest), self.tPOITypes.tTrackedQuestActive[1])
	if not useTAShowHandler then return end
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	if (L_BlockedFuncsInShowHandler[infoFrom.funcName]~=nil) then return end
	local level=4
	local nups=0
	while true do
		local n,v = debug.getlocal(level, nups+1) 
		if (v~=nil) then
		  nups=nups+1
		else
		  break;
		end
	end	 
    local name,val=debug.getlocal(level,nups-2)
	if (val==nil) then return end
	if (type(val)=="userdata") then
		GRB:TranslateWnd(val,settings)
	end
end
L_TraceAfter["GetActiveEvents"]=function(settings,infoFrom)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local level=4
	local name,val=debug.getlocal(level,1)
	if val==nil then return end
	--SendVarToRover("val",val,0)
	--TODO сделать выгрузку и перевод по Id PublicEventObjective
end
--============================ END Trace After Block =================================--
function GRB:TranslateItem(tItemInfo)
    if (tItemInfo==nil) then return end
	local changed=false
	--SendVarToRover("tItemInfo "..tItemInfo.tPrimary.strName, tItemInfo, 0)
	if (tItemInfo.tPrimary==nil) then return end
	if (tItemInfo.tPrimary.nId==nil) then return end
	local id=tItemInfo.tPrimary.nId
	local nStack=1
	if (tItemInfo.tPrimary.tStack.nCount~=nil) then 
		if (tItemInfo.tPrimary.tStack==nil) then 
			nStack=tItemInfo.tPrimary.tStack.nCount
		end
	end
	--если есть спеллы
	if tItemInfo.tPrimary.arSpells~=nil then
		local arSpells=tItemInfo.tPrimary.arSpells
		if type(arSpells)=="table" then
			for idx, tSpellInfo in pairs(arSpells) do
				local splData=tSpellInfo.splData
				if (splData~=nil) then
					local spellId=splData:GetId()
					if (spellId~=nil) and (L_Spells[spellId]~=nil) then
						local lSpellInfo=L_Spells[spellId]
						if (lSpellInfo.localizedTextIdName~=nil) then
							tItemInfo.tPrimary.arSpells[idx].strName=lSpellInfo.localizedTextIdName
							changed=true
						end
						if (lSpellInfo.localizedTextIdActionBarTooltip~=nil) then
							tItemInfo.tPrimary.arSpells[idx].strFlavor=lSpellInfo.localizedTextIdActionBarTooltip
							changed=true
						end
					end
				end 
			end
		end
	end
	-- если есть перевод итема
	if (L_Items[id]~=nil) then
		--SendVarToRover("tItemInfo "..id, tItemInfo, 0)
		--SendVarToRover("L_Items "..id, L_Items[id], 0)
		--сохраняем оригинальное название
		tItemInfo.tPrimary.strNameOriginal=tItemInfo.tPrimary.strName
		-- если есть общий перевод итема
		if (L_Items[id].a~=nil) then
			tItemInfo.tPrimary.strName=L_Items[id].a
			changed=true
		else
			--если есть перевод итема в единственном числе и оно одно в стэке
			if ((nStack==nil) or (nStack==1)) and (L_Items[id].o~=nil) then
				tItemInfo.tPrimary.strName=L_Items[id].o
				changed=true
			end
			--если есть перевод итема в множественном числе
			if  ((nStack~=nil) and (nStack>1)) and (L_Items[id].m~=nil) then
				tItemInfo.tPrimary.strName=L_Items[id].m
				changed=true
			end
		end
	else
		-- если инфы по итему не было в таблице итемов
		local strName=tItemInfo.tPrimary.strName
		if strName~=nil then
			local strRU=GRB:TranslateStringOrReturnSame(strName)
			tItemInfo.tPrimary.strName=strRU
			changed=true
		end
	end
	--перевод описания итема
	local strFlavor=tItemInfo.tPrimary.strFlavor
	if strFlavor~=nil then
		local strRU=GRB:TranslateStringOrReturnSame(strFlavor)
		tItemInfo.tPrimary.strFlavor=strRU
		changed=true
	end	
	if changed then return tItemInfo end
end
function GRB:GetQuestAttribute(id,attr)
	local strRU=nil
	if L_Quests[id]==nil then return strRU end
	local q=L_Quests[id]
	if attr=="Summary" then
		strRU=q.localizedTextIdText
	end
	if attr=="CompletedSummary" then
		strRU=q.localizedTextIdCompletedSummary
	end
	if attr=="CompletionObjectiveShortText" then
		strRU=q.localizedTextIdCompletedObjectiveShort
	end
	if attr=="CompletionObjectiveText" then
		strRU=q.localizedTextIdCompletionOverride
	end
	if strRU~=nil then
		strRU=String_GetWeaselString(strRU)
	end	
	return strRU
end
function GRB:TranslateLoadedForm(xmlDoc,loadedWindow,formName,settings)
	--GRB:DebugOut("Переводим новым методом форму "..formName)
	local t=xmlDoc:ToTable()
	for idx, tCurr in pairs(t) do
		if (type(tCurr)=="table") then
			if (tCurr.Name==formName) then
				self:TranslateLoadedFormRecursive(tCurr,loadedWindow,settings)
			end
		end
	end
end
function GRB:TranslateLoadedFormRecursive(xmlTable,loadedWindow,settings)
	if xmlTable==nil then return end
	if type(loadedWindow)~="userdata" then return end
	if xmlTable.Class~=nil then--12345
				if (settings.f==nil) or (settings.f==1)  then -- шрифт
					if (xmlTable.Font~=nil) then  	--if (loadedWindow.SetFont==nil) then return end
						local strFontNew=L_FONTS[xmlTable.Font]
						if strFontNew~=nil then
							loadedWindow:SetFont(strFontNew)
						end
					end
				end
				if (settings.t==nil) or (settings.t==1) then -- Перевод
					if (xmlTable.TextId~=nil) then
						local strRU;
						if L_Interface[xmlTable.TextId]~=nil then
							strRU=L_Interface[xmlTable.TextId]
							loadedWindow:SetText(strRU)
						end
					end
				end
	end
	-- перевод текстов окон
	for idx, tCurr in pairs(xmlTable) do
		if (type(tCurr)=="table") then
			local ok=true
			if tCurr.__XmlNode~=nil then
				if tCurr.__XmlNode=="Event" then ok=false end
				if tCurr.__XmlNode=="zzEvent" then ok=false end
			end
			if tCurr.Name==nil then ok=false end
			
			if ok then
				local child=loadedWindow:FindChild(tCurr.Name)
				if child~=nil then
					self:TranslateLoadedFormRecursive(tCurr,child,settings)
				else
					--SendVarToRover("not found="..tCurr.Name,tCurr,0)
				end
			end
		end
	end
	-- перевод pixie
	-- Строим таблицу Pixie
	local pTable={}
	local nPixieId = 1
	while true do 
		local _, tPixieInfo = pcall(function() return loadedWindow:GetPixieInfo(nPixieId) end)
		if tPixieInfo ~= nil then
			pTable[nPixieId]=tPixieInfo
		else
			break
		end
		nPixieId = nPixieId + 1
	end	
	local cntPixies=nPixieId-1
	for i=1,cntPixies do
		--loadedWindow:DestroyPixie(i)
	end
	if (nPixieId>1) then
		--SendVarToRover("PTable",pTable,0)
	end
	--перебираем pixie в xml-документе
	local n=1
	for idx, tCurr in pairs(xmlTable) do
		local ok=false
		if (type(tCurr)=="table") then
			if tCurr.__XmlNode~=nil then
				if tCurr.__XmlNode=="Pixie" then ok=true end
			end
		end
		if ok then
			local pInfo=self:GetPixieInfoFromXMLDefinition(tCurr,settings)
			loadedWindow:AddPixie(pInfo)
			n=n+1
			--SendVarToRover("Pixie2",pInfo,0)
		end
	end --перебираем pixie в xml-документе
	
end
function GRB:GetPixieInfoFromXMLDefinition(tCurr,settings)
	local pInfo={
			strTooltip="",
			strSprite=tCurr.Sprite,
			fRotation=0,
			bLine=tCurr.Line==1,
			cr=ApolloColor.new(tCurr.BGColor),
			crText=ApolloColor.new(tCurr.TextColor),
			flagsText ={},
			loc={
					fPoints ={tonumber(tCurr.LAnchorPoint),tonumber(tCurr.TAnchorPoint),tonumber(tCurr.RAnchorPoint),tonumber(tCurr.BAnchorPoint),},
					nOffsets ={tonumber(tCurr.LAnchorOffset),tonumber(tCurr.TAnchorOffset),tonumber(tCurr.RAnchorOffset),tonumber(tCurr.BAnchorOffset),},
				},
		}
	--флаги текста
	if (tCurr.DT_CENTER~=nil) and (tCurr.DT_CENTER=="1") then pInfo.flagsText.DT_CENTER=true end
	if (tCurr.DT_VCENTER~=nil) and (tCurr.DT_VCENTER=="1") then pInfo.flagsText.DT_VCENTER=true end
	if (tCurr.DT_RIGHT~=nil) and (tCurr.DT_RIGHT=="1") then pInfo.flagsText.DT_RIGHT=true end
	if (tCurr.DT_BOTTOM~=nil) and (tCurr.DT_BOTTOM=="1") then pInfo.flagsText.DT_BOTTOM=true end
	--перевод текста
	if (tCurr.TextId~=nil and tCurr.TextId>"") then -- установка текста в пикси
		pInfo.strText=Apollo.GetString(tCurr.TextId)
		if (settings.t==nil) or (settings.t==1) then -- Перевод текста
			if (tCurr.TextId>"") then
				pInfo.strText=GRB:TranslateStringEnum(tCurr.TextId)
			else
				if (tCurr.Text>"") then
					pInfo.strText=GRB:TranslateStringOrReturnSame(tCurr.Text)
				end
			end
		end
	end
	--подмена шрифтов
	pInfo.strFont=tCurr.Font
	if (settings.t==nil) or (settings.t==1) then -- Подмена шрифта
		if (tCurr.Font~=nil) and (tCurr.Font>"") then
			local newFont=L_FONTS[tCurr.Font]
			if newFont~=nil then
				pInfo.strFont=newFont
			end
		end
	end
	return pInfo
end
function GRB:TranslateSpell(str,settings)
	if (settings.t~=nil) and (settings.t==0) then return end --выход если перевод отключен
	local strOutNumbers = string.gsub(string.gsub(string.gsub(str,"^(%+?%-?%d*%.?%d+)","@"),"[^%a%p%$](%+?%-?%d*%.?%d+)"," @"),"\n","\\n")
	local erazeWrong = string.gsub(str,"[%a%$](%+?%-?%d*%.?%d+)","E")
	--GRB:DebugOut("strOutNumbers="..strOutNumbers)
	local strOutNumbersTr = GRB:TranslateString(strOutNumbers)
	if strOutNumbersTr==nil then return nil end
	--GRB:DebugOut("strOutNumbersTr="..strOutNumbersTr)
	local strTr = string.gsub(string.gsub(strOutNumbersTr,"@",string.gmatch(erazeWrong,"(%+?%-?%d*%.?%d+)")),"\\n","\n")
	return strTr
end
function GRB:GetAllDebugInfo(level)
	-- возвращает кроме Sf параметров так же в info
	-- info.funcName = имя вызывающей функции
	-- info.addonName= имя вызывающего аддона
	local info = debug.getinfo(level,"Sfn")
	if info==nil then return info end
	if (info.what=="Lua") then
		-- кэш имен функций (если аддон содержит определение self)
		local funcCache=L_FCACHE[info.func]
		if funcCache==nil then
			funcCache={}
			funcCache.func=GRB:GetFuncName(info,level+1)
			local addonName,luaName=GRB:GetAddonNameFromSource(info.source)
			funcCache.addon=addonName
			funcCache.luaName=luaName
			if funcCache.addon~=nil then --кэшируем данные аддона, в основном для отладки
				-- кэш имя аддона-список функций-адрес каждой 
				if L_ADDONFCACHE[funcCache.addon]==nil then 
					L_ADDONFCACHE[funcCache.addon]={} 
				end
				L_ADDONFCACHE[funcCache.addon][info.func]=funcCache.func
				--if funcCache.func~=nil then
				--	L_ADDONFCACHE[funcCache.addon][funcCache.func]={func=info.func}
				--end
			end
			L_FCACHE[info.func]=funcCache
		end
		if funcCache~=nil then
			info.funcName=funcCache.func
			info.addonName=funcCache.addon
			info.luaName=funcCache.luaName
			if (gatherDebugInfo) then
				local funcName=info.funcName
				if funcName==nil then funcName="nil" end
				if (info.addonName~=nil) then
					if L_DEBUG_CALLS[info.addonName]==nil then L_DEBUG_CALLS[info.addonName]={} end
					if L_DEBUG_CALLS[info.addonName][funcName]==nil then L_DEBUG_CALLS[info.addonName][funcName]=0 end
					L_DEBUG_CALLS[info.addonName][funcName]=L_DEBUG_CALLS[info.addonName][funcName]+1
				end
			end
		end
		-- вычисление имени аддона
		
	end
	--if (info.what=="C") then
	--end
	if (info) and (info.addonName) then
		if (L_Saved_Settings.AddonsStock[info.addonName]==nil) and (L_Saved_Settings.AddonsUser[info.addonName]==nil) then
			L_Saved_Settings.AddonsUser[info.addonName]=L_Saved_Settings.Stub
		end
	end
	return info
end
function GRB:GetFuncName(info,level)
	local idx=1
	while true do
		local ln, lv = debug.getlocal(level, idx)
		if ln ~= nil then
			if ln=="self" and lv~=nil and type(lv)=="table" then
				local err,meta=pcall(function() return lv.__index end) -- затычка для хитрожопого GeminiLocale
				if meta==nil then
					meta=lv.__newindex
				end
			    if meta~=nil and type(meta)=="table" then 
					for fName, fValue in pairs(meta) do
						if fValue==info.func then
							return fName
						end	
					end	
				end
			end
		else
			break
		end
		idx = 1 + idx
	end	
	return nil
end
function GRB:GetAddonNameFromSource(source)
	local addonName="---"
	local luaName=nil
	source=string.lower(source)
	if source~=nil then
		--local m=string.gmatch(source,"[%w_]+\\[%w_]+%.%a+$")
		--local m=string.match(source,"[%w_]+\\[%w_]+%.%a+$")
		local m=string.match(source,"[^\\]+\\[^\\]+%.lua$") --"abilities\\abilitiesbuilder.lua"
		if m~=nil then 
			addonName=string.lower(string.match(m,"[^\\]+")) --"abilities"
			luaName=string.lower(string.match(m,"[^\\]+%.lua$")) --abilitiesbuilder.lua
		end	
	end
	return addonName,luaName
end
function GRB:PrintFullScope(lev)
	local level=lev+1
	while true do
		GRB:DebugOut("---------LEVEL "..level.."-------------")
		--local info = debug.getinfo(level,"Slnuf")
		local info = GRB:GetAllDebugInfo(level+1)
		if info==nil then break end
		GRB:DebugOut("info.source="..(info.source or "nil") )
		if info.source~=nil then
			local addonName,luaName=GRB:GetAddonNameFromSource(info.source)
			GRB:DebugOut("Addon name="..addonName )
			
		end
		GRB:DebugOut("info.short_src="..(info.short_src or "nil"))
		GRB:DebugOut("info.linedefined="..(info.linedefined or "nil"))
		GRB:DebugOut("info.what="..(info.what or "nil"))
		GRB:DebugOut("info.namewhat="..(info.namewhat or "nil"))
		GRB:DebugOut("info.nups="..(info.nups or "nil"))
		GRB:DebugOut("info.func="..type(info.func))

		local s=info.funcName
		
		if s~=nil then
			GRB:DebugOut("function name="..s)
		else 
			GRB:DebugOut("function name=nil")
		end
		--for k,v in pairs(info) do 
			--if (k~=nil) and (v~=nil) then
				--GRB:DebugOut(k..type(v)) 
			--end
		--end
		GRB:DebugOut("Variables:")
		local idx=1
		while true do
			local ln, lv = debug.getlocal(level, idx)
			if ln ~= nil then
				GRB:DebugOut("var "..ln.."="..type(lv))
				if ln=="self" then
				  --local meta=ln.metatable
				  --local idx=meta.__index
				  
				  --SendVarToRover(ln.."_lev"..level, lv, 1)
				  --SendVarToRover(ln.."_lev"..level.."_func", info.func, 1)
				end
			else
				break
			end
			idx = 1 + idx
		end	
		level=level+1
	end
end
function GRB:TranslateStringOrReturnSame(source)
	local strRU=GRB:TranslateString(source)
	if strRU==nil then strRU=source end
	return strRU
end
function GRB:TranslateString(source)
	if (source==nil) then return nil end
	if useTranslatedCache and (L_AlreadyTranslated[source]~=nil) then return end
	
	local strRU=L_RU[source]
	if useTranslatedCache and strRU~=nil then
		L_AlreadyTranslated[strRU]=1
	end
	return strRU
end
function GRB:TranslateStringEnum(source)
	local strRU=L_Interface[source]
	if strRU==nil then
	end
 	if useTranslatedCache and strRU~=nil then
 		L_AlreadyTranslated[strRU]=1
	end
	return strRU
end
function GRB:SetWindowFont(wnd) -- отключено
	if true then return end -- подмена шрифта перенесена в TranslateForm
	if wnd==nil then return end
	local _, strFont = pcall(function() return wnd:GetFont() end)
	if strFont==nil then return end
	local newFont=L_FONTS[strFont]
	if newFont~=nil then 
		wnd:SetFont("CRB_AlienMedium")
	end	
end
function GRB:ApplyFilter(wndName,strText,isFontFilter)
	local filter=nil
	local strRU=nil
	if wndName~=nil then
		if isFontFilter then
			filter=L_CFF[wndName]
		else
			filter=L_CF[wndName]
		end
	end	
	
	if filter==nil then return strRU end
	local show=false
	--if wndName=="ArticleText" then show=true end
	if show then
		--GRB:DebugOut("WndName="..wndName)
		--GRB:DebugOut("strText="..strText)
		--GRB:DebugOut("filter="..filter[1])
	end
	local rule=filter[1]
	--получаем массив фильтров
	local filters=filter[2]
	--кол-во фильтров
	local cntFilters=table.getn(filters)
	--перебираем все фильтры по этому окну
	for j=1,cntFilters do
		local currentFilter=filters[j]
		--фильтр - это массив строк
		local cnt=table.getn(currentFilter)
		
		--GRB:DebugOut("cnt="..cnt)
		strRU=strText --берем начальный текст
		if rule==0 then
			for i=1,cnt do
				local ifilter=currentFilter[i]
				if show then GRB:DebugOut("ifilter="..ifilter) end
				for k, v in string.gmatch(strText, ifilter) do
					if show then GRB:DebugOut("i="..i) end
					if k~=nil and k~="" then
						if show then 
							GRB:DebugOut("k="..k) 
							if isFontFilter then GRB:DebugOut("isFontFilter=true") else GRB:DebugOut("isFontFilter=false") end
						end
						local s=nil
						if isFontFilter then
							s=L_FONTS[k] -- подменяем шрифты
						else
							s=GRB:TranslateString(k) -- переводим все совпадения
						end
						if s~=nil then
							if show then  GRB:DebugOut("s="..s) end
							strRU=string.gsub(strRU, ifilter,s) -- подменяем их
						end	
					end	
					if v~=nil then
						if show then GRB:DebugOut("v="..v) end
					end	
				end
			end --for
		end
		
		if rule==1 then
			local sClean=strText --берем начальный текст
			for i=1,cnt do
				local ifilter=currentFilter[i]
				if show then GRB:DebugOut("ifilter="..ifilter) end
				for k, v in string.gmatch(strText, ifilter) do
					if show then GRB:DebugOut("i="..i) end
					if k~=nil and k~="" then
						if show then GRB:DebugOut("k="..k) end
						sClean=string.gsub(sClean, ifilter,"") -- удаляем вхождения
					end	
					if v~=nil then
						if show then GRB:DebugOut("v="..v) end
					end	
				end
			end --for
			if show then GRB:DebugOut("sClean="..sClean) end
			local s=nil
			if isFontFilter then
				s=L_FONTS[sClean] -- подменяем шрифты
			else
				s=GRB:TranslateString(sClean) -- переводим все совпадения
			end
			if s~=nil then
				if show then GRB:DebugOut("trans="..s) end
				strRU=string.gsub(strText,GRB:EscapeCharacters(sClean),s)
			end
		end
		strText=strRU --для нового шага цикла
		
	end

	return strRU
end
function GRB:TranslateControlByName(wndName,strText)
	local strRU=GRB:ApplyFilter(wndName,strText,false)
	if strRU==nil then --обычный перевод если не отработал фильтр
		strRU=GRB:TranslateString(strText)
	end
	if strRU==nil then
		strRU=GRB:ApplyFilter("#Default#",strText,false) -- isFontFilter=false
	end
	--- первый фильтр прошел
	--- фильтруем шрифты
	local strText2=nil
	if strRU==nil then
		strText2=strText;
	else
		strText2=strRU;
	end
	strRU=GRB:ApplyFilter(wndName,strText2,true) -- isFontFilter=true
	if strRU==nil then
		if strText2~=strText then
			return strText2
		else
			return nil
		end
	else
		return strRU
	end
end
function GRB:EscapeCharacters(str)
	 local matches =
		{
		["^"] = "%^";
		["$"] = "%$";
		["("] = "%(";
		[")"] = "%)";
		["%"] = "%%";
		["."] = "%.";
		["["] = "%[";
		["]"] = "%]";
		["*"] = "%*";
		["+"] = "%+";
		["-"] = "%-";
		["?"] = "%?";
		["\0"] = "%z";
		}
	 return (str:gsub(".", matches))
end
function GRB:TranslateForm(formDef,wndParent,level,settings)
	if wndParent == nil then return	end
	if formDef==nil then return end --не переводим отключенные элементы формы
	if formDef==nil then -- если не выгружено определение формы - ставим шрифт по умолчанию
		if (settings.f==nil) or (settings.f==1) then
		 pcall(function() return wndParent:SetFont("DefaultButton") end)
			
		end
	else -- если выгружено определение формы 
		if (settings.f==nil) or (settings.f==1) then -- Шрифты
			if formDef.strFont~=nil and formDef.strFont~="" then wndParent:SetFont(formDef.strFont) end
		end
		--тексты
		if (settings.t==nil) or (settings.t==1) then -- Тексты
			if formDef.strEnum~=nil and L_Interface[formDef.strEnum]~=nil then 
				-- текст окна есть в Enum
				wndParent:SetText(GRB:TranslateStringEnum(formDef.strEnum))
			else
				--если текста окна нет в enum пытаемся перевести его через обычный текст
				if formDef.strText~=nil and formDef.strText~="" then wndParent:SetText(GRB:TranslateStringOrReturnSame(formDef.strText)) end
			end
			--тултипы
			if formDef.strTooltipEnum~=nil and L_Interface[formDef.strTooltipEnum]~=nil then 
				-- тултип окна есть в Enum
				wndParent:SetTooltip(GRB:TranslateStringEnum(formDef.strTooltipEnum)) 
			else
				--если тултипа окна нет в enum пытаемся перевести его через обычный текст
				if formDef.strTooltip~=nil and formDef.strTooltip~="" then wndParent:SetTooltip(GRB:TranslateStringOrReturnSame(formDef.strTooltip)) end
			end
			--текст приглашения к вводу
			if formDef.strPromptEnum~=nil and L_Interface[formDef.strPromptEnum]~=nil then 
				-- приглашение окна есть в Enum
				wndParent:SetPrompt(GRB:TranslateStringEnum(formDef.strPromptEnum)) 
			else
				--если приглашения окна нет в enum пытаемся перевести его через обычный текст
				if formDef.strPrompt~=nil and formDef.strPrompt~="" then wndParent:SetPrompt(GRB:TranslateStringOrReturnSame(formDef.strPrompt)) end
			end
			-- смещения контролов и окон
			local nLeft, nTop, nRight, nBottom = wndParent:GetAnchorOffsets()
			local changed=false;
			--относительные координаты
			if formDef.setTop~=nil then
				nTop=nTop+formDef.setTop
				changed=true;
			end
			if formDef.setBottom~=nil then
				nBottom=nBottom+formDef.setBottom
				changed=true;
			end
			if formDef.setLeft~=nil then
				nLeft=nLeft+formDef.setLeft
				changed=true;
			end
			if formDef.setRight~=nil then
				nRight=nRight+formDef.setRight
				changed=true;
			end
			--абсолютные
			if formDef.Top~=nil then
				nTop=formDef.Top
				changed=true;
			end
			if formDef.Bottom~=nil then
				nBottom=formDef.Bottom
				changed=true;
			end
			if formDef.Left~=nil then
				nLeft=formDef.Left
				changed=true;
			end
			if formDef.Right~=nil then
				nRight=formDef.Right
				changed=true;
			end
			if changed then
				wndParent:SetAnchorOffsets(nLeft, nTop, nRight, nBottom)
			end
		end
			
		--end
		if (settings.t==nil) or (settings.t==1) then -- Перевод pixie
			--local wndName=wndParent:GetName()
		  -- This code block will probably not do anything except loop through each pixie as strText is never(?) returned
		  -- Once GetPixieInfo returns a complete table, this should spring to life (and hopefully not bug out).
		  -- Строим таблицу Pixie


			local pTable={}
			local nPixieId = 1
			while true do 
				local _, tPixieInfo = pcall(function() return wndParent:GetPixieInfo(nPixieId) end)
				if tPixieInfo ~= nil then
					pTable[nPixieId]=tPixieInfo
				else
					break
				end
				nPixieId = nPixieId + 1
			end	

			local cntPixies=nPixieId-1
			local wndName=wndParent:GetName() 
			if (formDef.Pixies~=nil) and (#formDef.Pixies==cntPixies) then -- обновляем пикси если только их количество совпадает с определениями
				--for i=1,cntPixies do
				--	local res=wndParent:DestroyPixie(i)
				--		if (dbg) then
				--SendVarToRover("res destroy= ",res,1)
				--		end					
				--end
				wndParent:DestroyAllPixies()
				
				for i=1,cntPixies do
				
					local pInfo=formDef.Pixies[i] -- берем данные из выгрузки
					
					if pInfo~=nil then

						if pInfo.strEnum~=nil and pInfo.strEnum~="" and L_Interface[pInfo.strEnum]~=nil then
							pInfo.strText=GRB:TranslateStringEnum(pInfo.strEnum)
						else
							if pInfo.strText~=nil and pInfo.strText~="" then
							  pInfo.strText=GRB:TranslateStringOrReturnSame(pInfo.strText)
							end
						end

						local addRes=wndParent:AddPixie(pInfo)
					else 
						local addRes=wndParent:AddPixie(pTable[i])
					end
					
					--wndParent:AddPixie(pTable[i])
				end
			end
		end
		
	end
	--- перебираем все дочерние окна независимо от наличия определений
	local _, tChildren = pcall(function() return wndParent:GetChildren() end)
	if tChildren ~= nil and type(tChildren) == "table" then
		for idx, wndCurr in pairs(tChildren) do
			if (wndCurr~=nil) then
				local name=wndCurr:GetName()
				local wndCurrDef=nil
				if formDef~=nil and formDef.Controls[name]~=nil then
					wndCurrDef=formDef.Controls[name]
				end
				GRB:TranslateForm(wndCurrDef,wndCurr,level+1,settings)
			end
		end
    end


end
function GRB:TranslateWnd(wndParent,settings)
	if wndParent == nil then
		return
	end
	if (settings.f==nil) or (settings.f==1) then 
		GRB:SetWindowFont(wndParent)
	end
	if (settings.t==nil) or (settings.t==1) then 
		do -- text fields
			-- ignore any errors thrown due to the control not having a GetText method
			local _, strText = pcall(function() return wndParent:GetText() end)
			if strText ~= nil and type(strText) == "string"  then
				local strRU=GRB:TranslateString(strText)
				if strRU~=nil then
					wndParent:SetText(strRU)
				end	
			end
		end
	end
	local _, tChildren = pcall(function() return wndParent:GetChildren() end)
	if tChildren ~= nil then
		for idx, wndCurr in pairs(tChildren) do
			if (wndCurr~=nil) then
				GRB:TranslateWnd(wndCurr,settings)
			end;	
		end
	end	
end

-----------------------------------------------------------------------------------------------
-- GRB settings functions
-----------------------------------------------------------------------------------------------

function GRB:OnGrbSlash()
	self:ShowConfigForm()
end
function GRB:ShowConfigForm()
	--чекбоксы
	local ButtonDefaultTextReplace=self.wndMain:FindChild("ButtonDefaultTextReplace")
	local ButtonDefaultFontReplace=self.wndMain:FindChild("ButtonDefaultFontReplace")
	ButtonDefaultTextReplace:SetCheck(L_Saved_Settings.Stub.t==1)
	ButtonDefaultFontReplace:SetCheck(L_Saved_Settings.Stub.f==1)
		-- выборочное отключение
	local ButtonDisableAlways=self.wndMain:FindChild("ButtonDisableAlways")
	local ButtonDisableInGroup=self.wndMain:FindChild("ButtonDisableInGroup")
	local ButtonDisableInRaid=self.wndMain:FindChild("ButtonDisableInRaid")
	local ButtonDisableInInstance=self.wndMain:FindChild("ButtonDisableInInstance")
	local ButtonDisableInNamePart=self.wndMain:FindChild("ButtonDisableInNamePart")
	local ButtonReloadOnChangedState=self.wndMain:FindChild("ButtonReloadOnChangedState")
	ButtonDisableAlways:SetCheck(L_Saved_Settings.DisableAlways==1)
	ButtonDisableInGroup:SetCheck(L_Saved_Settings.DisableInGroup==1)
	ButtonDisableInRaid:SetCheck(L_Saved_Settings.DisableInRaid==1)
	ButtonDisableInInstance:SetCheck(L_Saved_Settings.DisableInInstance==1)
	ButtonDisableInNamePart:SetCheck(L_Saved_Settings.DisableInNamePart==1)
	ButtonReloadOnChangedState:SetCheck(L_Saved_Settings.ReloadOnChangedState==1)
	--Стоковые аддоны
	local wndParent = self.wndMain:FindChild("AddonStockList")
    self.wndMain:Show(true) -- show the window defined in MyAddon:OnLoad()

	
	for AddonName, AddonRules in pairs(L_Saved_Settings.AddonsStock) do
		if (AddonRules.s==nil) or (AddonRules.s==1) then
			local wndAddonItem = self:LoadByName("AddonListItem", wndParent, AddonName)
			wndAddonItem:FindChild("AddonName"):SetText(AddonName)
			wndAddonItem:FindChild("TranslateButton"):SetCheck((AddonRules.t==nil) or (AddonRules.t==1))
			wndAddonItem:FindChild("ChangeFontsButton"):SetCheck((AddonRules.f==nil) or (AddonRules.f==1))
		end
	end
	wndParent:ArrangeChildrenVert(0, function (a,b) return a:FindChild("AddonName"):GetText() < b:FindChild("AddonName"):GetText() end)
	--пользовательские аддоны
	local wndParent = self.wndMain:FindChild("AddonUserList")
    self.wndMain:Show(true) -- show the window defined in MyAddon:OnLoad()
	for AddonName, AddonRules in pairs(L_Saved_Settings.AddonsUser) do
		if (AddonRules.s==nil) or (AddonRules.s==1) then
			local wndAddonItem = self:LoadByName("AddonListItem", wndParent, AddonName)
			wndAddonItem:FindChild("AddonName"):SetText(AddonName)
			wndAddonItem:FindChild("TranslateButton"):SetCheck((AddonRules.t==nil) or (AddonRules.t==1))
			wndAddonItem:FindChild("ChangeFontsButton"):SetCheck((AddonRules.f==nil) or (AddonRules.f==1))
		end
	end
	wndParent:ArrangeChildrenVert(0, function (a,b) return a:FindChild("AddonName"):GetText() < b:FindChild("AddonName"):GetText() end)
	
	
	--for i=1,1000 do
	--	local wndAddonItem = self:LoadByName("AddonListItem", wndParent, "i="..i)
	--	wndAddonItem:FindChild("TranslateButton"):SetCheck(true)
	--	
	--end --for
end

function GRB:OnChangeFontsButtonChecked()
end
function GRB:OnChangeFontsButtonUnchecked()
end
function OnTranslateButtonChecked()
end
function OnTranslateButtonUnchecked()
end
function GRB:LoadByName(strForm, wndParent, strCustomName)
	local wndNew = wndParent:FindChild(strCustomName)
	if not wndNew then
		wndNew = Apollo.LoadForm(self.xmlDoc , strForm, wndParent, self)
		wndNew:SetName(strCustomName)
	end
	return wndNew
end
function GRB:OnTranslateButtonChecked(wndHandler, wndControl)
	if wndHandler ~= wndControl then return end
	wndControl:SetCheck(true)
end
function GRB:OnTranslateButtonUnchecked(wndHandler, wndControl)
	if wndHandler ~= wndControl then return end
	wndControl:SetCheck(false)
end
function GRB:GetAddonsList()
	self.tAddons = GetAddons()
end
function GRB:OnOKAndReload()
	self:OnOK()
	RequestReloadUI()
end
function GRB:OnOK()
    self.wndMain:Show(false) -- hide the window
	--чекбоксы
	local ButtonDefaultTextReplace=self.wndMain:FindChild("ButtonDefaultTextReplace")
	local ButtonDefaultFontReplace=self.wndMain:FindChild("ButtonDefaultFontReplace")
	if ButtonDefaultTextReplace:IsChecked() then
		L_Saved_Settings.Stub.t=1
	else
		L_Saved_Settings.Stub.t=0
	end
	if ButtonDefaultFontReplace:IsChecked() then
		L_Saved_Settings.Stub.f=1
	else
		L_Saved_Settings.Stub.f=0
	end
	-- выборочное отключение
	local ButtonDisableAlways=self.wndMain:FindChild("ButtonDisableAlways")
	local ButtonDisableInGroup=self.wndMain:FindChild("ButtonDisableInGroup")
	local ButtonDisableInRaid=self.wndMain:FindChild("ButtonDisableInRaid")
	local ButtonDisableInInstance=self.wndMain:FindChild("ButtonDisableInInstance")
	local ButtonDisableInNamePart=self.wndMain:FindChild("ButtonDisableInNamePart")
	local ButtonReloadOnChangedState=self.wndMain:FindChild("ButtonReloadOnChangedState")
	if ButtonDisableAlways:IsChecked() then
		L_Saved_Settings.DisableAlways=1
	else
		L_Saved_Settings.DisableAlways=0
	end
	if ButtonDisableInGroup:IsChecked() then
		L_Saved_Settings.DisableInGroup=1
	else
		L_Saved_Settings.DisableInGroup=0
	end
	if ButtonDisableInRaid:IsChecked() then
		L_Saved_Settings.DisableInRaid=1
	else
		L_Saved_Settings.DisableInRaid=0
	end
	if ButtonDisableInInstance:IsChecked() then
		L_Saved_Settings.DisableInInstance=1
	else
		L_Saved_Settings.DisableInInstance=0
	end
	if ButtonDisableInNamePart:IsChecked() then
		L_Saved_Settings.DisableInNamePart=1
	else
		L_Saved_Settings.DisableInNamePart=0
	end
	if ButtonReloadOnChangedState:IsChecked() then
		L_Saved_Settings.ReloadOnChangedState=1
	else
		L_Saved_Settings.ReloadOnChangedState=0
	end
	
	--Конфа для стоковых аддонов
	local wndParent = self.wndMain:FindChild("AddonStockList")
	local _, tChildren = pcall(function() return wndParent:GetChildren() end)
	if tChildren ~= nil then
		for idx, wndAddonItem in pairs(tChildren) do
			if (wndAddonItem~=nil) then
				local AddonName=wndAddonItem:FindChild("AddonName"):GetText()
				if AddonName~="" and AddonName~=nil then
					if (wndAddonItem:FindChild("TranslateButton"):IsChecked()) then
						L_Saved_Settings.AddonsStock[AddonName].t=1
					else
						L_Saved_Settings.AddonsStock[AddonName].t=0
					end
					if wndAddonItem:FindChild("ChangeFontsButton"):IsChecked() then
						L_Saved_Settings.AddonsStock[AddonName].f=1
					else
						L_Saved_Settings.AddonsStock[AddonName].f=0
					end
				end
			end
		end
    end	
	--Конфа для пользовательских аддонов
	local wndParent = self.wndMain:FindChild("AddonUserList")
	local _, tChildren = pcall(function() return wndParent:GetChildren() end)
	if tChildren ~= nil then
		for idx, wndAddonItem in pairs(tChildren) do
			if (wndAddonItem~=nil) then
				local AddonName=wndAddonItem:FindChild("AddonName"):GetText()
				if AddonName~="" and AddonName~=nil then
					if (wndAddonItem:FindChild("TranslateButton"):IsChecked()) then
						L_Saved_Settings.AddonsUser[AddonName].t=1
					else
						L_Saved_Settings.AddonsUser[AddonName].t=0
					end
					if wndAddonItem:FindChild("ChangeFontsButton"):IsChecked() then
						L_Saved_Settings.AddonsUser[AddonName].f=1
					else
						L_Saved_Settings.AddonsUser[AddonName].f=0
					end
				end
			end
		end
    end	
	self:ApplySettings()
end
function GRB:OnDefaultSettingsButton()
	L_Saved_Settings=L_Settings
	GRB:OverrideSettings(L_Saved_Settings) --добавляем наши фиксы
	self.wndMain:Show(false)
	self:ShowConfigForm()
	self:ApplySettings()
end
function GRB:OnCancel()
    self.wndMain:Show(false) -- hide the window
end
function GRB:OnSave(eType)
	if eType == GameLib.CodeEnumAddonSaveLevel.General then
		if (L_Saved_Settings.Version) and (L_Saved_Settings.Version==L_Settings.Version) then
			return L_Saved_Settings
		else
			return L_Settings
		end
	else
		return
	end
end
function GRB:OnRestore(eType, tSavedData)
	if eType == GameLib.CodeEnumAddonSaveLevel.General then
		if (tSavedData) and (tSavedData.Version) and (tSavedData.Version==L_Settings.Version) then
			L_Saved_Settings=tSavedData
		else
		  L_Saved_Settings=L_Settings
		end
		GRB:OverrideSettings(L_Saved_Settings) --добавляем наши фиксы
		L_Saved_Settings.VersionMinor=L_Settings.VersionMinor
	end
	self:ApplySettings()
end
function GRB:ApplySettings()
	--L_Saved_Settings содержат нужные настройки
	if L_Saved_Settings.DisableAlways==nil then 
		L_Saved_Settings.DisableAlways=L_Settings.DisableAlways
	end
	if L_Saved_Settings.DisableInGroup==nil then 
		L_Saved_Settings.DisableInGroup=L_Settings.DisableInGroup
	end
	if L_Saved_Settings.DisableInRaid==nil then 
		L_Saved_Settings.DisableInRaid=L_Settings.DisableInRaid
	end
	if L_Saved_Settings.DisableInInstance==nil then 
		L_Saved_Settings.DisableInInstance=L_Settings.DisableInInstance
	end
	if L_Saved_Settings.DisableInNamePart==nil then 
		L_Saved_Settings.DisableInNamePart=L_Settings.DisableInNamePart
	end
	if L_Saved_Settings.ReloadOnChangedState==nil then 
		L_Saved_Settings.ReloadOnChangedState=L_Settings.ReloadOnChangedState
	end
	
	self:SetHookState()
end
function GRB:GetDisabledState()
	local inGroup=GroupLib.InGroup()
	local inRaid=GroupLib.InRaid()
	local inInstance=GroupLib.InInstance()
	
	local b1=L_Saved_Settings.DisableAlways==0
	local b2=L_Saved_Settings.DisableInGroup==0 or (not inGroup)
	local b3=L_Saved_Settings.DisableInRaid==0 or (not inRaid)
	local b4=L_Saved_Settings.DisableInInstance==0 or (not inInstance)
	
	local hookMustEnabled=b1 and b2 and b3 and b4
	
	return hookMustEnabled
end
function GRB:SetHookState()
	f, mask, count = debug.gethook ()
--	local hookEnabled=true
--	if (f==nil) or (mask==nil) or (mask=="") then
--		hookEnabled=false
--	end
--	if hookEnabled then
--		self:DebugOut("hookEnabled=1")
--	else
--		self:DebugOut("hookEnabled=0")
--	end
	
	local hookMustEnabled=self:GetDisabledState()
	
--	if hookMustEnabled then
--		self:DebugOut("hookMustEnabled=1")
--	else
--		self:DebugOut("hookMustEnabled=0")
--	end	
	if hookEnabled and (not hookMustEnabled) then
		--выключаем аддон
		debug.sethook()
		hookEnabled=false
		firstHookEnable=false
		self:DebugOut("Выключаем аддон")
		if L_Saved_Settings.ReloadOnChangedState==1 then
			RequestReloadUI()
		end
	end
	if (not hookEnabled) and (hookMustEnabled) then
		--включаем аддон
		debug.sethook(L_Trace, "cr")    -- в контексте аддона в обработчик не передается why поэтому трейс - фя глобальная
		hookEnabled=true
		firstHookEnable=false
		self:DebugOut("Включаем аддон")
		if L_Saved_Settings.ReloadOnChangedState==1 then
			RequestReloadUI()
		end
	end
	
end
function GRB:OnGroupUpdated()
	self:SetHookState()
end

-----------------------------------------------------------------------------------------------
-- GRB Functions
-----------------------------------------------------------------------------------------------
-- Config button to the side of OPTIONS
function GRB:OnConfigure()
	self:ShowConfigForm()
end
function GRB:DebugOut(text)
	Print("GRB: "..text)
end
function GRB:OnGrbTest()
	local callsCount={}
	local idx=0
	for name_addon,addon_table  in pairs(L_DEBUG_CALLS) do
		for func_name, func_calls in pairs(addon_table) do
			local s=name_addon.."_"..func_name
			if func_calls~=nil and s~=nil and func_calls>0 then
				idx=idx+1
				callsCount[idx]={}
				callsCount[idx].calls=func_calls
				callsCount[idx].addon=name_addon
				callsCount[idx].func=func_name
			end
		end
	end
	
	table.sort(callsCount,function(a,b) return a.calls>b.calls end)
	--table.sort(callsCount)
	--SendVarToRover("callsCount",callsCount,0)
end
-----------------------------------------------------------------------------------------------
-- Debug Functions
-----------------------------------------------------------------------------------------------

function GRB:OnGrbDebug()
	self.wndDebug:Show(true)
	Apollo.RegisterTimerHandler("GRBDebugTimer", "UpdateDebugInfo", self)
	--Runs the CreateTimer method specified with strTimerName, nInterval, bContinuous.
	Apollo.CreateTimer("GRBDebugTimer",3, true)	
	gatherDebugInfo=true
end
function GRB:OnDebugClose()
	gatherDebugInfo=false
	Apollo.StopTimer("GRBDebugTimer")	
    self.wndDebug:Show(false)
end
function GRB:UpdateDebugInfo()
	local wndList = self.wndDebug:FindChild("AddonPerfomanceData")
	-- Очищаем список
	local childs=wndList:GetChildren()
	
	if (childs~=nil) then
		for idx, wndCurr in pairs(childs) do
			if (wndCurr~=nil) then
				wndCurr:Destroy()
			end
		end
	end
	--строим новый список
	for name_addon,addon_table  in pairs(L_DEBUG_CALLS) do
		local wndNew = Apollo.LoadForm(self.xmlDoc , "AddonPerfomanceItem", wndList, self)
		-- считаем вызовы по аддону
		local calls=0
		--сортируем
		local iterator=function(a,b)
			return a.c>b.c
		end
		local sorted_addon_table={}
		for func_name, func_calls in pairs(addon_table) do
			sorted_addon_table[#sorted_addon_table + 1]={n=func_name,c=func_calls}
		end
		table.sort(sorted_addon_table,iterator)
		--показываем
		local nshow=0
		local textShow=""
		for idx, func_data in pairs(sorted_addon_table) do
			calls=calls+func_data.c
			addon_table[func_data.n]=0
			nshow=nshow+1
			if nshow<4 then
				textShow=textShow.." "..func_data.n.."("..func_data.c..")"
			end
		end
		--запишем результат в data
		wndNew:FindChild("AddonString"):SetData(calls)
		--строим текст
		
		local text=name_addon.." calls="..calls.." "..textShow
		
		wndNew:FindChild("AddonString"):SetText(text)
	end
	--сортируем
	wndList:ArrangeChildrenVert(0, function (a,b) 
									local aa=a:FindChild("AddonString"):GetData() 
									local bb=b:FindChild("AddonString"):GetData() 
									return  aa>bb 
									end)	
end
-----------------------------------------------------------------------------------------------
-- Bubble Functions
-----------------------------------------------------------------------------------------------

function GRB:OnUnitTextBubbleToggled(tUnitArg, strText, nRange)
	if true then 
		return
	end
	local mt = getmetatable(tUnitArg)
	mt.__index.HasTextBubble=false
	if tUnitArg.AddTextBubble2==nil then
		--t = {}
		 --setmetatable(t, tUnitArg)
		--tUnitArg.zzz=1 --tUnitArg.AddTextBubble
		--tUnitArg.AddTextBubble=GRB.tUnitArgAddTextBubble
		local mt = getmetatable(tUnitArg)
		mt.__index.AddTextBubble2=tUnitArg.AddTextBubble
		mt.__index.AddTextBubble=GRB.tUnitArgAddTextBubble
		mt.__index.HasTextBubble=false
		SendVarToRover("mt",mt,0)
	end 
	GRB:PrintFullScope(0)
	--GRB:PrintFullScope(1)
	if false then
		local func=tUnitArg.AddTextBubble
		
		--local ln, lv = debug.getupvalue(infoFrom.func, idx)
		SendVarToRover("unit",tUnitArg,0);
		SendVarToRover("unitfunc",func,0);
		
		
		local n,v = debug.getlocal(0,0)
		SendVarToRover("0-0",v,0);
		local n,v = debug.getlocal(0,1)
		SendVarToRover("0-1",v,0);
		local n,v = debug.getlocal(0,2)
		SendVarToRover("0-2",v,0);
		local n,v = debug.getlocal(0,3)
		SendVarToRover("0-3",v,0);
		local n,v = debug.getlocal(0,4)
		SendVarToRover("0-4",v,0);
		local n,v = debug.getlocal(0,5)
		SendVarToRover("0-5",v,0);
		local n,v = debug.getlocal(0,6)
		SendVarToRover("0-6",v,0);
		
		
		
		local n,v = debug.getlocal(1,0)
		SendVarToRover("1-0",v,0);
		local n,v = debug.getlocal(1,1)
		SendVarToRover("1-1",v,0);
		local n,v = debug.getlocal(1,2)
		SendVarToRover("1-2",v,0);
		local n,v = debug.getlocal(1,3)
		SendVarToRover("1-3",v,0);
		local n,v = debug.getlocal(1,4)
		SendVarToRover("1-4",v,0);
		local n,v = debug.getlocal(1,5)
		SendVarToRover("1-5",v,0);
		
		return
	end
end
-----------------------------------------------------------------------------------------------
-- MyAddon Instance
-----------------------------------------------------------------------------------------------
local GrbAddonInst = GRB:new()
GrbAddonInst:Init()

